
#line 6 "Code.mx"

/* Copyright (C) 1998-2001 Contributors

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by 
*  the Free Software Foundation; either version 2 of the License, or 
*  (at your option) any later version. 
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of 
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
*  GNU General Public License for more details. 
*
*  You should have received a copy of the GNU General Public License 
*  along with this program; if not, write to the Free Software 
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/
 

#include	<stdio.h>
#include	"Mx.h"
#include	"MxFcnDef.h"

extern	Tok *	FstTok();
extern	Tok *	NxtTok();
extern	Tok *	SkipTok();
extern	Def *	GetDef();


#line 36 "Code.mx"
void	GenCode()
{
    Def *	d;
    char *	fname;
    int		bak;

    for( d= defs; d < defs + ndef; d++ ){
	mx_file= d->d_file;
	mx_line= d->d_line;
again:  switch( d->d_dir ){
	case Bfile:
	case Ofile:
	    fname= d->d_cmd;
	    break;
	case Efile:
	    UpdateFiles();
	    break;
	case Title:
	case Author:
	case Version:
	case Date:
	    break;
	case Module:
	case Section:
	case Ifdef:
	case Ifndef:
	case Endif:
	case Paragraph:
	case Continue:
	case Qtex:
	case Qcode:
	    break;
	case Cdef:
	case Csrc: 	
	case CCsrc: 
	case cppsrc:	
	case Clex:
	case Cyacc:
	case Prolog:
	case OQLspec:
	case ODLspec:
	  case phasme:
	case PILcode:
	case Qnap:
	case Pspec:
	case Pimpl:
	case Java:
	case Tcl:
            if(!extract(d->d_dir)) break;
	    WriteFile(fname, d->d_dir);
	    mode=d->d_dir;
	    CodeBlk(d->d_blk);
	    break;
	case Mxmacro:
	    break;
	case Index0:
	case Index1:
	case Index2:
	case Index3:
	case Index4:
	case Index5:
	case Index6:
	case Index7:
	case Index8:
	case Index9:
	    break;
        case InHide:
            HideOn();
            if (bak >= Qtex) {
                d->d_dir = bak;
                goto again;
            } break;
        case OutHide:
            HideOff();
            if (bak >= Qtex) {
                d->d_dir = bak;
                goto again;
            } break;
	    /* POONLAP BEGIN */
 case InUserdoc:
 case OutUserdoc:
     break; /* Do nothing */
     /* POONLAP END */
	default:
	    Fatal("GenCode", "Unknown directive:%c", d->d_dir);
	}
	bak = d->d_dir;
    }
}



#line 129 "Code.mx"
void	CodeBlk( char *blk)
{
Tok *	t;
char *	c;

	CodeLine();
	
	for( t= FstTok(blk); t != (Tok *)NULL; t= NxtTok(t) ){
		switch( t->t_dir ){
		case T_INDEX:
			ofile_printf("%s", t->t_str);
			break;
		case T_REFERENCE:
			CodeSub(t->t_str);
			CodeLine();
			break;
		case T_SGML:
		case T_NONE:
			for( c= t->t_str; *c; c++ )
				if( *c == '\n' ) mx_line++;
			ofile_printf("%s", t->t_str);
			break;
		case T_HIDETEXT:
			t = SkipTok(t,T_ENDHIDE);
			break;
		case T_BEGARCHIVE:
			t = SkipTok(t,T_ENDARCHIVE);
			break;
		case T_ENDARCHIVE:
		case T_BEGHIDE:
		case T_ENDHIDE:
			break;
		default:
			Fatal("CodeBlk", "Unknown directive:%c", t->t_dir);
		}
	}
	ofile_printf("\n");
}

void	CodeSub(call)
char *	call;
{
Def *	def;
char *	blk;
char *	file= mx_file;
int	line= mx_line;
char **	argv= MkArgv(call);
	
	def= GetDef(argv[0]);
	if( def ){
		blk= CodeSubBlk(def->d_blk, argv);
		mx_file= def->d_file;
		mx_line= def->d_line;
		CodeBlk(blk);
	} else
		UnRef(argv[0]);
		
	argv= RmArgv(argv);
	mx_file= file;
	mx_line= line;
}

static	char	blk[4096];



#line 196 "Code.mx"
char *	CodeSubBlk(sub, argv)
char *	sub;
char **	argv;
{
char *	s;
char *	b;
char *	a;

	s= sub; b= blk;
	while( *s ){
		if( (s[0] == MARK)  && (s[-1] != '\\') &&
				(('1' <= s[1]) && (s[1] <= '9')) ){
			s++;
			for( a = argv[*s - '0']; a && *a;)
				*b++= *a++;
			s++;
		} else
			*b++= *s++;
	}
	*b= '\0';
	return StrDup(blk);
}



#line 222 "Code.mx"
void	UnRef(ref)
char *	ref;
{
	Error("Unresolved reference:%s", ref);
	if( mode & M_CODE && textmode==M_TEX )
		ofile_printf("/* Unresolved Reference :%s */", ref);
	if( mode & M_CODE && textmode==M_MS)
		ofile_printf("/* %s */", ref);
	/* should text for actual source format */
}



#line 236 "Code.mx"
void	CodeLine()
{
	switch( mode ){
	case Prolog:
	case Cyacc:
	case Clex:
	case Java:
		ofile_printf("\n/* %s:%d */\n", mx_file, mx_line);
		break;
	case Tcl:
		ofile_printf("\n# %s:%d \n", mx_file, mx_line);
		break;
	default:
		ofile_printf("\n#line %d \"%s\"\n", mx_line, mx_file);
		break;
	}
}

