
#line 8 "Def.mx"
/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include	<stdio.h>
#include        <string.h>
#include 	<time.h>
#include	"Mx.h"
#include	"MxFcnDef.h"

extern char * mx_title;
extern char * mx_date;
extern char * mx_version;
extern char * mx_author;

extern int  condSP;
Def *NwDef();

#define MAXIF   20
struct{
    int defined;
    char *macro;
} condStack[MAXIF];

Def* defs = 0;
int  ndef = 0;


#define topCond() (condStack[condSP-1].defined)
#define topMacro() (condStack[condSP-1].macro)
#define pushCond(X,N) { condStack[condSP].defined = (X);\
			condStack[condSP++].macro = StrDup(N); }
#define toggle() {if(topCond())condStack[condSP-1].defined=0;\
                  else condStack[condSP-1].defined=1;}
#define popCond() {if(condSP) condSP--;else Fatal("DefDir","IFDEF error");}

int allTrue()
{
    int i;
    for(i=0; i < condSP; i++)
	if (!condStack[i].defined) return 0;
    return 1;
}
    


void	InitDef()
{
    long clock;

    mx_title = 0;
    time(&clock);
    mx_date = ctime(&clock);
    mx_author = "";
    mx_version = "";
    pushCond(1,"");
    if( defs == 0 )
	defs= (Def *) Malloc(sizeof(Def) * M_DEFS);
}

void	MakeDefs(name)
char *	name;
{
    Def 	*d;
    CmdCode	dir;
    char 	*line, *str, *cmd, *blk;
    extern int	pr_hide;
    int		i, mod= 0, sec= 0, lino;
    CmdCode 	lastdir = Continue;

    ReadFile(name);
    d= NwDef(Bfile, mod, sec);
    d->d_cmd= name;

    while ((line = NextLine()) && *line != '@'); 
    PrevLine();
    while( !EofFile() ){
	dir = DefDir();
	lino = mx_line;
	cmd = DefCmd();
	blk = DefBlk();

	switch(dir){
/*
 * conditional text and code
 * Syntax:
 *     @if <macroId>\n <block> [@else <block> ] @endif
 */
	case Ifdef:
	    pushCond(GetDef(cmd)!=NULL,cmd);
	    if (allTrue()){
		d = NwDef(dir, mod, sec, lino);
		d->d_cmd = cmd;
		d->d_blk = NULL;
		if(allTrue()){
		    d = NwDef(lastdir, mod, sec, lino);
		    d->d_cmd = NULL;
		    d->d_blk = blk;
		}
	    }
	    
	    break;
	case Ifndef:
	    toggle();
	    if(allTrue()){
		d = NwDef(dir, mod, sec, lino);
		d->d_cmd = topMacro();
		d->d_blk = NULL;
		d = NwDef(lastdir, mod, sec, lino);
		d->d_cmd = NULL;
		d->d_blk = blk;
	    }
	    break;
	case Endif:
	    if(!topCond())toggle();
	    
	    if (allTrue()){
		d = NwDef(dir, mod, sec, lino);
		d->d_cmd = topMacro();
		d->d_blk = NULL;
	    }
	    popCond();
	    if (allTrue()){
		d = NwDef(lastdir, mod, sec, lino);
		d->d_cmd = NULL;
		d->d_blk = blk;
	    }
	    break;
 /*
  * Define index.
  * Syntax:@<n><string>\n@...
  */
	case Index0:
	case Index1:
	case Index2:
	case Index3:
	case Index4:
	case Index5:
	case Index6:
	case Index7:
	case Index8:
	case Index9:
	    if (allTrue()){
		IndexTable(dir, cmd);
		d = NwDef(dir, mod, sec, lino);
		d->d_cmd = cmd;
		d->d_blk = blk;
		lastdir = Continue;
	    }
	    break;
 /*
  * Define title, author, date, version.
  * Syntax: tavd]<string>\n...
  */
	case Title:
	    if (allTrue()){
		    mx_title = cmd;
		    d= NwDef(dir, mod, sec, lino);
		    d->d_cmd= cmd;
		    lastdir = Continue;
	    }
	    break;
	case Version:
	    if (allTrue()){
		    mx_version = cmd;
		    d= NwDef(dir, mod, sec, lino);
		    d->d_cmd= cmd;
		    lastdir = Continue;
	    }
	    break;
	case Author:
	    if (allTrue()){
		    mx_author = cmd;
		    d= NwDef(dir, mod, sec, lino);
		    d->d_cmd= cmd;
		    lastdir = Continue;
	    }
	    break;
	case Date:
	    if (allTrue()){
		    mx_date = cmd;
		    d= NwDef(dir, mod, sec, lino);
		    d->d_cmd= cmd;
		    lastdir = Continue;
	    }
	    break;
 /*
  * Text directives: chapter, section, paragraph.
  * Syntax:*+ ]<string>\n<blok>...
  * Synatx:@\n<blok>@...
  */
	case Module:
	    if (allTrue()){
		if (!Hide()) { mod++; sec= 0; }
		d= NwDef(dir, mod, sec, lino);
		d->d_cmd= cmd;
		d->d_blk= blk;
		if (!Hide()) IndexEntry(0, d->d_cmd,d->d_mod, d->d_sec);
		lastdir = Continue;
	    }
	    break;
	case Section:
	    if (allTrue()){
		if (!Hide()) sec++;
		d= NwDef(dir, mod, sec, lino);
		d->d_cmd= cmd;
		d->d_blk= blk;
		if (!Hide()) IndexEntry(0, d->d_cmd,d->d_mod, d->d_sec);
		lastdir = Continue;
	    }
	    break;
	    
	case Paragraph:
		if (allTrue()){
			d= NwDef(dir,mod,sec, lino);
			d->d_blk = blk;
			d->d_cmd = cmd;
			lastdir = Continue;
		}
		break;
	case Qtex:
	case Qcode:
	case Continue:
	    if (allTrue()){
		d= NwDef(dir, mod, sec, lino);
		d->d_blk= blk;
		lastdir = Continue;
	    }
	    break;
 /*
  * Code directives, 
  * Pool: spec, impl
  * C:    .h, .c, .cc, .y, .l
  * Monet:    .mil, .m
  * Basename
  * Syntax:sihcylfp]\n<blk>\n...
  */
	case Ofile:
	    if (allTrue()){
		d= NwDef(dir, mod, sec, lino);
		d->d_cmd= cmd;
		lastdir = Continue;
	    }
	    break;
	case Pspec:
	case Pimpl:
	case Cdef:
	case Csrc:
	case CCsrc:
	case cppsrc:
	case Cyacc:
	case Clex:
	case Prolog:
	case phasme:
	case PILcode:
	case WWW:
	case ODLspec:
	case OQLspec:
	case Java:
	case Tcl:
	case Qnap:
	    if (allTrue()){
		d= NwDef(dir, mod, sec, lino);
		d->d_cmd = cmd;
		d->d_blk = blk;
		lastdir = dir;
	    }
	    break;
/*
 * Macro definitions.
 * Syntax:@=<def>\n<blok>\n@... 
 */
	case Mxmacro:
	    if (allTrue()){
		d= NwDef(dir, mod, sec, lino);
		d->d_cmd = cmd;
		d->d_blk = blk;
		/*add information */
		lastdir = Continue;
	    }
	    break;
	case InHide:
	    d = NwDef(dir, mod, sec, lino);
	    d->d_cmd = cmd;
	    d->d_blk = blk;
	    HideOn();
	    break;
	case OutHide:
	    d = NwDef(dir, mod, sec, lino);
	    d->d_cmd = cmd;
	    d->d_blk = blk;
	    HideOff();
	    break;
	    /* POONLAP BEGIN */
/*	case Userdoc:
	    d = NwDef(dir, mod, sec, lino);
	    d->d_cmd = cmd;
	    d->d_blk = blk;
	    lastdir = Continue;
	    break;*/
	case InUserdoc:
	    d = NwDef(dir, mod, sec, lino);
	    d->d_cmd = cmd;
	    d->d_blk = blk;
	    /*HideOff();*/
	    /* I don't know why I do this */
	    lastdir = Continue;
	    break;
	case OutUserdoc:
	    d = NwDef(dir, mod, sec, lino);
	    d->d_cmd = cmd;
	    d->d_blk = blk;
	    /*HideOff();*/
	    /* I don't know why I do this */
	    lastdir = Continue;
	    break;
	    /* POONLAP END */
	default:
	    Fatal("MakeDefs", "Unknown directive:%c%c", MARK, dir);
	    break;
	}
    }
    d= NwDef(Efile, mod, sec, lino);
    CloseFile();
    pr_hide = 0;
}

char * dir2ext(dir)
    CmdCode dir;
{
    Directive *d = str2dir;

    if(dir == Bfile)
	if(textmode == M_WWW) 
		return "html";
	else 
		return "tex";

    while (d->cmd != (char *)0){
        if (d->code == dir)
            return d->ext;
        d++;
    }
    return "";
}


CmdCode lookup(str)
    char *str;
{
    Directive *d = str2dir;
    
    while (d->cmd != (char *)0){
	if (strcmp(str, d->cmd) == 0)
	    return d->code;
	d++;
    }
    return 0;
}

char *dir2str(dir)
    CmdCode dir;
{
    Directive *d = str2dir;
    
    while (d->cmd != (char *)0){
	if (dir == d->code) 
	    return d->cmd;
	d++;
    }
    return "(nil)";
}

char *line;

char *substr(s,sep)
    char *s,*sep;
{
    int loc;
    
    loc = strcspn(s,sep);
    if (loc==strlen(s)) return NULL; else return s+loc;
}

int	DefDir()
{
     char        *dir;
     int         dircode;

     line = NextLine();

     if ((line[0] == MARK) && ((dir = substr(line," \t\n")) != NULL)){
	 *dir = '\0'; 
	 dircode = lookup(line+1);
	 line = dir+1;
	 if (dircode) return dircode;
     }
     else return 0;

     Error("Non directive:%s",line);
     return 0;
 }

 char * DefCmd()
 {

     char *f=line;
     char *l;

     while(*f && ((*f == ' ') || (*f == '\t'))) f++;
     l = f;
     while (*l && (*l != '\n')){
	 if ((*l == MARK) && (*(l-1) != '\\')) {
	     Error("Mark(%c) unexpected:%s", MARK, f);
	     return 0;
	 }
	 l++;
     }
     *l = '\0';
     return StrDup(f);
}

static	char	blk[ M_BLK+2];
char *
DefBlk()
{
	char *	f;
	int size = 0;
	char *dir;
	char sep;

	f= blk; 
	
	line = NextLine();

	*f = '\0';
	while( line != NULL ) {
	    size = strlen(line);
	    if((*line == MARK) && ((dir = substr(line+1," \t\n")) != NULL)){
		sep = *dir;
		*dir = '\0';
		if (lookup(line+1)) break;
		*dir = sep;
	    }
	    if (f + size + 1 > blk + M_BLK)
		Fatal("Mx:Too long block, use extra directives:[%s:%d].\n",
		      mx_file,mx_line);
	    strcat(f,line); f += size; 
	    line = NextLine();
	}
	if(line) {*dir = ' '; PrevLine(); }
	if( f == blk )	return 0;



	return StrDup(blk);
}

Def *	NwDef(dir, mod, sec, lino)
char	dir;
int	mod;
int	sec;
int     lino;
{
Def *	d;

	if( ndef ==   M_DEFS )
		Fatal("NwDef", "Too many definitions.");	
	d= defs + ndef++;

	d->d_dir= dir;
	d->d_cmd= 0;
	d->d_blk= 0;
	d->d_mod = mod;
	d->d_sec = sec;
	d->d_file = mx_file;
	d->d_line = lino;
	DbDef(d);
	return d;
}

Def *
GetDef(str)
char *	str;
{
Def *	d;

	for( d= defs; d < defs + ndef; d++ ){
		if( (d->d_cmd)&&(strcmp(str, d->d_cmd) == 0) )
		    switch(d->d_dir){
		    case Ifdef:
		    case Endif:
		    case Ifndef:
			break;
		    default:
			return d;
		    }
	}
	return 0;
}

void	DbDef(d)
Def *	d;
{
	if( (db_flag & DB_DEF) != DB_DEF )
		return;
	Message("Def:d %c;c %s;m %d;s %d\n",
		d->d_dir, d->d_cmd, d->d_mod, d->d_sec);
	Message("Def:b>>%s<<\n", d->d_blk);
}

