
#line 6 "Display.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include	<stdio.h>
#include	"Mx.h"
#include	"MxFcnDef.h"

#define TEXMODE (textmode==M_TEX)
#define WWWMODE (textmode==M_WWW)
/* Printing modes
 *	Formatted text	Plain/Math.
 *		Math is used for special symbols.
 *	Formatted code
 */

extern	int	Hide();
/* POONLAP BEGIN */
extern int userdoc;
extern int opt_userdoc;
extern char *	mx_title;
extern char *	mx_author;
extern char *	mx_version;
extern char *	mx_date; 
/* POONLAP END */

void	PrFontStr(s, c)
char *	s;
char	c;
{
	if( Hide() ) return;
	/* POONLAP BEGIN */
	if( !DoPrint ) return;
	    /* POONLAP END */
	switch( c ){
	case T_BOLD:
		PrCmd(TEXMODE? "{\\bf " : WWWMODE? "<B>" : "\\fB");
		PrText(s);
		PrCmd(TEXMODE? "}":WWWMODE? "</B>" : "\\fP" );
		break;
	case T_ITALIC:
		PrCmd(TEXMODE? "{\\it " : WWWMODE? "<I>" : "\\fI");
		PrText(s);
		PrCmd(TEXMODE? "}" : WWWMODE? "</I>" : "\\fP");
		break;
	case T_CODE:
		PrCmd(TEXMODE? "{\\tt " : WWWMODE? "<TT>" : "\\fB");
		PrText(s);
		PrCmd(TEXMODE? "}" : WWWMODE? "</TT>" : "\\fP");
		break;
	}
	PrEnv(E_TEXT);
}

void	PrModeStr(s, c)
char *	s;
char	c;
{
	if( Hide() ) return;

	/* POONLAP BEGIN */
	if( !DoPrint ) return;
	    /* POONLAP END */
	switch( c ){
	case T_CODE:
		PrCode(s);
		break;
	case T_TEX:
		PrCmd(s);
		break;
	}
	PrEnv(E_TEXT);
}

void	PrCmd(s)
char *	s;
{
	extern int pr_pos;
	if( Hide() ) return;
	/* POONLAP BEGIN */
	if( !DoPrint()) return;
	    /* POONLAP END */
	if( !s ) return;

	PrEnv(E_CMD);
	ofile_puts(s);
        pr_pos += strlen(s);
}


void	PrText(s)
char *	s;
{
	if( Hide() ) return;
	/* POONLAP BEGIN */
	if( !DoPrint() )
	    /* POONLAP END */
	if( !s ) return;

	PrEnv(E_TEXT);
	PrStr(s);
}

void	PrCode(s)
char *	s;
{
	if( Hide() ) return;
	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	if( !s ) return;

	PrEnv(E_CODE);
	PrStr(s);
}

char filename_body[200]={0}, filename_index[200]={0};

void	PrRule(tail)
char *tail;
{
	static int oldRule = 0;

	if( Hide()) return;
	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	if TEXMODE{


	    if (tail){
		strcpy(strchr(filename,'.')+1, tail);
		/*ofile_printf("\n\n\\noindent\\rule{\\linewidth}{1pt}\\newline");*/
		ofile_printf("\n\n\\noindent\\makebox[\\linewidth][r]{\\small\\tt ");
		PrTxt(filename);
		ofile_printf("}\n\\vspace{-1 em}\\noindent");
	    }
	    /*else 
		ofile_printf("\\vspace{-1em}\\noindent\\rule{\\linewidth}{1pt}\n");*/
	} else if WWWMODE {
		if (tail) strcpy(strchr(filename,'.')+1, tail);
		if (oldRule==0) {
			ofile_printf("\n<hr size=1 noshade>");
			ofile_printf("<table width=\"100%%\"><tr>");
			ofile_printf("<td align=right valign=top>");
			ofile_printf("<font size=\"-1\"><i>%s",filename);
			ofile_printf("</i></font></td></tr></table>\n");
		} 
	} else {
		if( oldRule==0){
			ofile_printf(".br\n.sp -0.5v\n");
			ofile_printf("\\l'\\n(.lu-\\n(.iu'\n");
			ofile_printf(".ps -1\n.vs -1\n.br\n");
			ofile_printf(".nf\n.na\n");
			if(tail){
				strcpy(strchr(filename,'.')+1, tail);
				ofile_printf("\\h'\\n(.lu-\\w'\\fI%s\\fP'u'", 
					filename);
				ofile_printf("\\v'-2u'");
				ofile_printf("\\fI%s\\fP",filename);
				ofile_printf("\\v'+2u'\\h'|0c'");
			}
		}else{
			ofile_printf("\n.sp -0.5v\n");
			ofile_printf("\\l'\\n(.lu-\\n(.iu'\n");
			ofile_printf(".ps +1\n.vs +1\n.br\n");
			ofile_printf(".fi\n.ad\n");
		}
	}
	oldRule++; oldRule %= 2;
}

extern char *bname;

void	PrPrelude(file)
char *file;
{
    extern char *texDocStyle;
    char *s,*t,full[200];

    /* find out the full name in 'full', the basename in 's', end in 't' */ 
    strcpy(full, file);
    for(s=full; s[1]; s++);
    while(s>=full && *s!='/') s--;
    for(t=++s; *t; t++) 
        if (t[0] == '.' && t[1] == 'm' && t[2] == 'x' && !t[3]) break; 
    *t = 0;




#line 213 "Display.mx"
		 if TEXMODE{
    /* POONLAP BEGIN */
    /* Time to change to LaTeX2e */
    ofile_printf("\\documentclass[twoside]{article}\n");
    ofile_printf("\\usepackage{graphics}\n");
    ofile_printf("\\usepackage{fancyhdr}\n");
    ofile_printf("\\pagestyle{fancy}\n");
    /*    ofile_printf("\\fancyhf{}\n");
    ofile_printf("\\fancyhead[RO]{\\leftmark}\n");
    ofile_printf("\\fancyhead[LE]{\\rightmark}\n");
    ofile_printf("\\fancyfoot[CE,CO]{\\thepage}\n");*/
    if(texDocStyle != NULL){
	ofile_printf("\\usepackage{%s}\n", texDocStyle);
    }
    ofile_printf("\\setlength{\\textwidth}{170mm}\n");
    ofile_printf("\\setlength{\\textheight}{230mm}\n");
    ofile_printf("\\setlength{\\oddsidemargin}{-5mm}\n");
    ofile_printf("\\setlength{\\evensidemargin}{-5mm}\n");
    ofile_printf("\\setlength{\\headwidth}{\\textwidth}\n");
    
    /* POONLAP END */

    /* COMMENT OUT BY POONLAP
       
       if(texDocStyle != NULL)
       ofile_printf("\\documentstyle%s\n",texDocStyle);
       else {
       ofile_printf("\\documentstyle[twoside,titlepage,epsf]{article}\n");
       ofile_printf("\\pagestyle{myheadings}\n");
       ofile_printf("\\textheight= 9.5 in\n");
       ofile_printf("\\textwidth= 6.5 in\n");
       ofile_printf("\\topmargin=-0.5 in\n");
       ofile_printf("\\oddsidemargin=-0.25 in\n");
       ofile_printf("\\evensidemargin=-0.25 in\n");
       ofile_printf("\\parindent=0 in\n");
       }
    */
    
	    if( opt_column == 2 ) ofile_printf("\\columnsep=0.5 in\n");
	    ofile_printf("\\newcommand{\\codesize}{\n");
	    ofile_printf("  %s}\n", opt_column==1? "\\small": "\\footnotesize");
	    ofile_printf("\\newcommand{\\eq}[1]{\n");
	    ofile_printf("  ${\\ \\equiv\\ }$}\n");
	    /* POONLAP BEGIN */
	    if( opt_userdoc==1 && (mx_author && mx_title ) ){
		ofile_printf("\\title{{%s}\\\\ \n \\ {%s}}\n", 
			     mx_title, mx_version);
		ofile_printf("\\author{%s}\n", mx_author);
	    }
	    		/* POONLAP END */
		

/*
   Starting ...
 */
	    ofile_printf("\\begin{document}\n");
	    /* POONLAP BEGIN */
	    if( opt_userdoc==1 && (mx_author && mx_title ) ){
		ofile_printf("\\maketitle\n\\tableofcontents\n\\clearpage\n");
	    }
	    /*ofile_printf("\\tableofcontents\n");*/
		/* POONLAP END */
	    
	    if( opt_column == 2 ) ofile_printf(",\\twocolumn\n");

    } else if WWWMODE {
    	    /* install the extra HTML filenames */
	    strcpy(filename_index, full);
	    strcpy(filename_body, full);

	    strcpy(filename_index + (t-full), ".index.html");
	    ofile_index = fopen(filename_index, "w");
	    strcpy(filename_body + (t-full), ".body.html");
	    ofile_body = fopen(filename_body, "w");
	    mx_out = 7; 
	    ofile_printf("<HTML>\n<HEAD>\n");
	    mx_out = 4;
	    ofile_printf("<BASE target=\"_parent\">\n");
	    mx_out = 7; 
	    ofile_printf("<TITLE>Module %s.mx</TITLE>\n</HEAD>\n",s);
	    mx_out = 1;
	    ofile_printf("<FRAMESET ROWS=\"83%%,17%%\">\n");
	    ofile_printf("\t<FRAME name=\"a\" src=\"%s.body.html\">\n",s);
	    ofile_printf("\t<FRAME src=\"%s.index.html\">\n",s);
	    ofile_printf("</FRAMESET>\n\n<NOFRAMES>\n");
	    mx_out = 7;
	    ofile_printf("<BODY bgcolor=\"#FFFFFF\" text=\"%s\" vlink=\"%s\" link=\"%s\">\n",text_color, vlnk_color, link_color);
	    mx_out = 5;
    } else {
	if( opt_column==2) ofile_printf(".2C\n");
    }
    PrEnv(E_CMD);
}

void	PrPostlude()
{
	PrEnv(E_CMD);
	if TEXMODE {
		ofile_printf("\\end{document}\n");
	} else if WWWMODE {
	    mx_out = 7;
	    ofile_printf("</BODY>\n</HTML>\n");
	    mx_out = 5;
	}
}



