
#line 7 "Form.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include	<stdio.h>
#include 	<pwd.h>
#include 	<ctype.h>
#include	"Mx.h"
#include	"MxFcnDef.h"

#define TEXMODE		(textmode==M_TEX)
#define WWWMODE		(textmode==M_WWW)
#define Newline		if WWWMODE { PrCmd("<br>"); } else if TEXMODE { PrCmd("\n"); } else { PrCmd(".LP\n"); }

extern	Def *	GetDef();
extern	Tok *	FstTok();
extern	Tok *	NxtTok();
extern	Tok *	SkipTok();
extern  int     pr_env;
extern	int	opt_hide;
extern  char *  texDocStyle;
extern  int codeline;

void	FormPar();

char *	mx_title= 0;
char *	mx_author= 0;
char *	mx_version= 0;
char *	mx_date= 0;
char	filename[200];
/* POONLAP BEGIN */
int userdoc = 0;
/*void PrUserdocTitle(void);*/
/* POONLAP END */

void	GenForm()
{
    Def *	d;
    File * 	f;
    int	bak, done_once = 0;
    int	lastdir=0;
    long	clock;
    char 	*getlogin();
    extern char bibtexfile[256];
    
    for(d=defs; d <defs+ndef && (d->d_dir != Bfile); lastdir=d->d_dir, d++);
    for(; d < defs + ndef; lastdir=d->d_dir, d++ ){
	codeline = d->d_line;
    again:  switch( d->d_dir ){
	/* POONLAP BEGIN */
    case Title:
	break;
    case Author:
/*	printf("d_cmd(author) = %s\n", d->d_cmd); */
	mx_author = StrDup(d->d_cmd);
	break;
    case Version:
/*	printf("d_cmd(version) = %s\n", d->d_cmd);*/
	mx_version = StrDup(d->d_cmd);
	break;
    case Date:
/*	printf("d_cmd(date) = %s\n", d->d_cmd);*/
	mx_date = StrDup(d->d_cmd);
	/* at last we produce the new footer */
	if(TEXMODE){
	    ofile_printf("\n\\lfoot[%s %s]{}\n", 
			 mx_version,
			 mx_date );
	    ofile_printf("\\rfoot[]{%s}\n", mx_author);
	}
	break;
	/* POONLAP END */
	
	/* COMMENT OUT BY POONLAP */
	/*
	  case Title:
	  case Author:
	  case Version:
	  case Date:
	  break;*/
	/* COMMENT OUT BY POONLAP */
    case Bfile:
	WriteFile(d->d_cmd, d->d_dir);
	PrPrelude(d->d_cmd);
	sprintf(filename,"%s",d->d_cmd);
	FormTitle();
	/* POONLAP BEGIN */
	/* printf("d_cmd %s\n", d->d_cmd);
	printf("d_blk %s\n", d->d_blk);
	printf("d_cms %s\n", d->d_cms);   
	printf("d_file %s\n", d->d_file);
	printf("%d\n", d->d_dir);*/
	/* POONLAP END */
	break;
    case Efile:
	PrIndex();
	PrPostlude();
	if (*bibtexfile) {
	    PrCmd("<hr size=5 noshade><br><br>"); 
	    bib_print();
	}
	UpdateFiles();
	break;
    case Ofile:
	sprintf(filename,"%s.",d->d_cmd);
	break;
    case Module:
	FormMod(d->d_cmd, d->d_mod);
	PrEnv(E_TEXT);
	FormBlk(d);
	Newline;
	break;
    case Section:
	FormSec(d->d_cmd, d->d_mod, d->d_sec);
	PrEnv(E_TEXT);
	FormBlk(d);
	Newline;
	break;
    case Paragraph:
	FormPar(d->d_cmd);
	PrEnv(E_TEXT);
	FormBlk(d);
	Newline;
	break;
    case Ifdef:
    case Ifndef:
    case Endif:
	{ 
	    int env = pr_env;
	    PrEnv(E_TEXT);
	    FormIf(d);
	    Newline;
	    PrEnv(env);
	}
    break;
    case Continue:
	FormBlk(d);
	Newline;
	break;
    case Qtex:
	if WWWMODE { 
	    latex2html(d->d_blk, lastdir!=Qtex, d[1].d_dir!=Qtex);
	} else { 
	    PrCmd(d->d_blk);
	    Newline;
	    PrEnv(E_TEXT);
	}
	break;
    case Qcode:
	PrCodeDisplay(d,"c");
	break;
    case Cdef:
	PrCodeDisplay(d,"h");
	break;
    case Pspec:
	PrCodeDisplay(d,"spec");
	break;
    case cppsrc:
	PrCodeDisplay(d,"cpp");
	break;
    case CCsrc:
	PrCodeDisplay(d,"cc");
	break;
    case Csrc:
	PrCodeDisplay(d,"c");
	break;
    case Clex:
	PrCodeDisplay(d,"lex");
	break;
    case Cyacc:
	PrCodeDisplay(d,"yacc");
	break;
    case PILcode:
	PrCodeDisplay(d,"pil");
	break;
    case phasme:
	PrCodeDisplay(d,"m");
	break;
    case OQLspec:
	PrCodeDisplay(d,"oql");
	break;
    case ODLspec:
	PrCodeDisplay(d,"odl");
	    break;
    case Prolog:
	PrCodeDisplay(d,"plg");
	break;
    case Qnap:
	PrCodeDisplay(d,"qnp");
	break;
    case Tcl:
	PrCodeDisplay(d,"tcl");
	break;
    case Java:
	PrCodeDisplay(d,"java");
	break;
    case Pimpl:
	PrCodeDisplay(d,"impl");
	break;
    case Mxmacro:
	PrEnv(E_TEXT); PrRule(0);
	if(WWWMODE){
	    int env = pr_env;
	    PrCmd("<a name=\""); PrCmd(d->d_cmd); PrCmd("\"><b><font size=\"-1\">");
	    PrCmd(d->d_cmd);PrCmd(" ::=</font></b>");
	    PrEnv(env);
	}
	else {
	    PrCode(d->d_cmd);
	    PrCode(" ::=\n");
	}
	if (!Hide()) 
	    IndexEntry(IFRAG, d->d_cmd, d->d_mod, d->d_sec);
	PrEnv(E_CODE); 
	FormBlk(d);
	PrEnv(E_TEXT); 
	PrRule(0);
	break;
    case Index0:
    case Index1:
    case Index2:
    case Index3:
    case Index4:
    case Index5:
    case Index6:
    case Index7:
    case Index8:
    case Index9:
	break;
    case InHide:
 	HideOn();
	if (bak >= Qtex) { 
	    d->d_dir = bak;
	    goto again;
	} break;
    case OutHide:
	HideOff();
	if (bak >= Qtex) { 
	    d->d_dir = bak;
	    goto again;
	} break;
	/* POONLAP BEGIN */
	/* case Userdoc:
	printf("There is Userdoc directive\n");
	printf("%s\n", d->d_blk);
	break;*/
    case InUserdoc:
      userdoc = 1;
      /*      printf("userdoc = %d\n", userdoc);*/
      break;
    case OutUserdoc:
      userdoc = 0;
      /* printf("userdoc = %d\n", userdoc);*/
      	/* POONLAP END */
      break;
    default:
	Fatal("GenForm", "Non directive:%s [%s:%d]",
	      dir2str(d->d_dir), d->d_file, d->d_line);
    }
    bak = d->d_dir;
    }
}

int EmptyDisplay(Def *d) {
    char *p;
    p=d->d_blk;
    if (p == NULL) return 1;
    while(isspace(*p)) p++;
    return (*p == '\0');
}

PrCodeDisplay(d,tail)
Def *d;
char *tail;
{
	if (!EmptyDisplay(d)){
	    PrRule(tail);
	    PrEnv(E_CODE); FormBlk(d);PrEnv(E_TEXT); 
	    PrRule(0);
	}
}

void FormIf(d)
    Def * d;
{
    if TEXMODE switch(d->d_dir){
    case Ifdef: 
/*
	PrCmd("\\framebox[\\linewidth]{ Variant ");
	PrStr(d->d_cmd);
	PrCmd("}\n");
 */
	break;
	
    case Ifndef:
	PrCmd("\\framebox[\\linewidth]{ Variant not(");
	PrTxt(d->d_cmd);
	PrCmd(")}\n");
	break;

    case Endif:
/*
	PrCmd("\\framebox[\\linewidth]{ End variant ");
	PrTxt(d->d_cmd);
	PrCmd("}\n");
 */
	break;
    }   
}
 
void	FormBlk(d)
Def *	d;
{
Tok *	t;
int	i;
	for( t= FstTok(d->d_blk); t; t= NxtTok(t) ){
		if (WWWMODE && (pr_env & E_CODE)) {
			PrCodeline();
		}
		switch( t->t_dir) { 
		case T_BOLD:
		case T_ITALIC:
		case T_CODE:
			PrFontStr(t->t_str, t->t_dir);
			break;
		case T_TEX:
			PrModeStr(t->t_str, t->t_dir);
			break;
		case T_INDEX:
			i= t->t_ext - '0';
	    		if (!Hide()) 
			    IndexEntry(i, t->t_str, d->d_mod, d->d_sec);
			PrStr(t->t_str);
			break;
		case T_SGML:
		{   int instr = 0, sgml = 0;
		    char *p;
		    /* sgml tags do not have width, correct this */ 
		    for(p=t->t_str; *p; p++) {
			if (!instr && *p == '<') {
				sgml = 1;
			} 
 			if (!sgml) PrChr(*p);
			else if (WWWMODE) ofile_putc(*p);
			if (*p == '"') {
				instr = !instr; 
			} else if (!instr && sgml) {
				if (*p =='>') sgml=0; 
			} 
		    }
		    break;
		}
		case T_REFERENCE:
			FormSub(t->t_str);
			break;
		case T_BEGHIDE:
			/*if( opt_hide != NO_HIDE ) */
				HideOn();
			break;
		case T_HIDETEXT:
			HideText();
			break;
		case T_ENDHIDE:
			/* if( opt_hide != NO_HIDE ) */
				HideOff();
			break;
		case T_BEGARCHIVE:
			archived= 1;
			break;
		case T_ENDARCHIVE:
			archived= 0;
		case T_NONE:
			PrStr(t->t_str);
			break;
			/* POONLAP BEGIN */
		/*case T_BEGINUSERDOC:
		  printf("Begin Userdoc\n");
		  break;*/
		  /* POONLAP END */
		default:
			Fatal("FormBlk", "Unknown directive:%c", t->t_dir);
		}
	}
}




#line 411 "Form.mx"
void	FormTitle()
{
	if( !(mx_author && mx_title ) )
		return;
		
	if( *mx_title ){
		PrCmd(TEXMODE? "\\title{" : WWWMODE ? 
			"<center><h1><font size=\"+3\"><p>" : ".TL\n\\s+2");
		/* COMMENT OUT BY POONLAP
		   PrText(mx_title);
		   COMMENT OUT BY POONLAP */
		/* POONLAP BEGIN */
		if( ! *global_title  ){
		    PrText(mx_title);
		} else {
		    PrText(global_title);
		}
		/* POONLAP END */
		if( mx_version && *mx_version ){
			PrCmd(TEXMODE? "\\\\\n\\ " : WWWMODE ?
				"</font></h1><h2><p><font size=\"+2\">" : "\n.sp\n\\fIVersion ");
			/* COMMENT OUT BY POONLAP
			PrText(mx_version);
			COMMENT OUT BY POONLAP */
			/* POONLAP BEGIN */
			if( ! *global_version ){
			PrText(mx_version);
			} else {
			    PrText(global_version);
			}
			/* POONLAP BEGIN */
		}
		PrCmd(TEXMODE? "}\n" : WWWMODE ? "<p></font></h2></center>\n" : 
						"\\s-2\n");
	}
	if( *mx_author ){
		PrCmd(TEXMODE? "\\author{" : WWWMODE ? 
			"<center><h3><font size=\"+1\"><p>" :".AU\n\\s+1");
		/* COMMENT OUT BY POONLAP 
		PrText(mx_author);
		COMMENT OUT BY POONLAP */
		/* POONLAP BEGIN */
		if( ! *global_author ){
		    PrText(mx_author);
		} else {
		    PrText(global_author);
		}
		/* POONLAP END */
		PrCmd(TEXMODE? "}\n" :WWWMODE? "<p></font></h3></center>":"\\s-1\n");
	}
	if( mx_date && *mx_date ){
		PrCmd(TEXMODE? "\\date{" : WWWMODE ? 
                        "<center><h3><font size=\"+1\"><p>" : "\n\\fBDate\\fP");
		PrText(mx_date);
		PrCmd(TEXMODE? "}\n" :WWWMODE? "<p></font></h3></center>":"\n");
	}
	PrCmd(TEXMODE ? "\\maketitle\n\\tableofcontents\n\\clearpage\n" : "");

	if(textmode==M_MS) PrCmd(".sp 2\n");
	if (texDocStyle == (char *)0) PrCont();
}

void	FormSub(str)
char *	str;
{
	Def *	d;
	char ** argv = MkArgv(str); 
	int env = pr_env;
	char *p = (char*) strchr(str, '(');

	if(textmode==M_MS) 
		PrCmd("\\fI");

	if (d = GetDef(argv[0]))
		if (p) *p = 0;

	if (WWWMODE) {
		if(env==E_CODE) {
			PrCodeline();
			pr_env=E_CMD;
		}
		if (d) {
			PrCmd("<a href=\"#");
			PrCmd(d->d_cmd);
			PrCmd("\">");
		}
		PrCmd("<i>");
		PrStr(str);
		PrCmd("</i>");
		if (d)	PrCmd("</a>");
	} else {
		PrStr(str);
		PrRef(d?d->d_mod:0, d?d->d_sec:0);
	}
	if (d && p) {
		char *backup = d->d_blk;
		*p = '('; d->d_blk = p;
		FormBlk(d);
		d->d_blk = backup;
	}
	if(textmode==M_MS) PrCmd("\\fI");
	else if (WWWMODE && (env==E_CODE)) pr_env=E_CODE;
	PrEnv(env);
}

int wwwmod=0, wwwsec=0, wwwpar=0;

/* handling a form module */
void	FormMod(str, mod)
char *	str;
int		mod;
{
	mx_title= str;
	if TEXMODE FormHeader(); 
	if TEXMODE {
		PrCmd("\\section{"); 
	} else if WWWMODE {
		PrCmd("<hr size=5 noshade><hr size=5 noshade><br><br>");
		PrCmd("<a name=mod_"); PrNum(wwwmod=mod); PrCmd("_0_0>\n<h2>"); 
		PrNum(mod); PrChr(' ');  
		wwwsec = wwwpar = 1;
	} else	{
		PrCmd(".ps+2\n.SH\n");
		PrNum(mod); PrStr(' '); 
	}
	PrEnv(E_TEXT);
	PrStr(str);
	if TEXMODE {
		PrCmd("}\n"); 
	} else if WWWMODE {
		PrCmd("</h2>\n"); 
	} else	PrCmd("\n.ps -2\n.LP\n");
}

void	FormSec(str, mod, sec)
char *	str;
int	mod;
int	sec;
{
	if TEXMODE {
		PrCmd("\\subsection{");
	} else if WWWMODE {
                PrCmd("<hr size=5 noshade><br><a name=mod_");
		PrNum(wwwmod=mod);PrChr('_');
		PrNum(wwwsec=sec);PrCmd("_0>\n<h4>"); wwwpar = 1;
		PrNum(mod);PrChr('.'); PrNum(sec);PrChr(' ');
	} else	{
		PrCmd(".SH\n");
		PrNum(mod);PrChr('.');PrNum(sec);PrChr(' ');
	}
	PrEnv(E_TEXT);
	PrStr(str);
	if TEXMODE {
		PrCmd("}\n"); 
	} else if WWWMODE {
		PrCmd("</h4>");
	} else	PrCmd("\n.LP\n");
}

void	FormPar(str)
char * str;
{
	if (str && (strlen(str) > 0)) {
		if TEXMODE {
			PrCmd("\\subsubsection{");
		} else if WWWMODE {
			PrCmd("<br><a name=mod_");
			PrNum(wwwmod);PrChr('_');
			PrNum(wwwsec);PrChr('_');
			PrNum(wwwpar);
			PrCmd(">\n<b>");
			PrNum(wwwmod);PrChr('.');
			PrNum(wwwsec);PrChr('.');
			PrNum(wwwpar++);PrChr(' ');
		} else {
			PrCmd("\n.LP\n");
		}
		PrEnv(E_TEXT);
		PrStr(str);
		if TEXMODE {
			PrCmd("}\n");
		} else if WWWMODE {
			PrCmd("</b><br>\n");
		} else {
			PrCmd("\n.LP\n");
		}
	} else {
		if TEXMODE {
			PrCmd("\\smallskip\n\\noindent");
		} else if WWWMODE {
			PrCmd("<p>");
		} else {
			PrCmd("\n.LP\n");
		}
	}
}

void	FormHeader()
{
    extern char *texDocStyle;
 
    if TEXMODE if (texDocStyle != NULL) return;

    /* COMMENT OUT ORIGINAL BY POONLAP 
	if TEXMODE PrCmd("\\markboth{ \\ \\ ");
	else if WWWMODE PrCmd("<p><h1 align=center>");
	else PrCmd(".TL\n");

	PrText(mx_title);

	if TEXMODE PrCmd("\\hfill ");
	else if WWWMODE PrCmd("</h1>\n\n<h2 align=center>");
	else 	PrCmd(".AU\n");

	PrText(mx_author);

	if TEXMODE PrCmd("}{\\ \\ ");
	else if WWWMODE PrCmd("</h2>\n\n<h3 align=center>");
	else	PrCmd("\\sp 2\n\\fBVersion \\fP");

	PrText(mx_version);

	if TEXMODE PrCmd("\\hfill ");
	else if WWWMODE PrCmd("</h3>\n\n<h4 align=center>");
	else	PrCmd("\n");

	PrText(mx_date);

	if TEXMODE PrCmd("}\n");
	else if WWWMODE PrCmd("</h4>\n\n");
    */

    /* POONLAP BEGIN */
    if( TEXMODE ){
	PrCmd("\\fancyhf{}\n");
	PrCmd("\\lhead[\\thepage]{\\rightmark}\n");
	PrCmd("\\rhead[\\leftmark]{\\thepage}\n");
	PrCmd("\\lfoot[version ");
	PrText(mx_version);
	PrCmd(" ");
	PrText(mx_date);
	PrCmd("]{}\n");
	PrCmd("\\rfoot[]{");
	PrText(mx_author);
	PrCmd("}\n");
        /*ofile_printf("\\tableofcontents\n");
	ofile_printf("\\clearpage\n");	
	*/

	/*	PrCmd("\\fancyhead[LE]{\\thepage}\n");
	PrCmd("\\fancyhead[RE]{\\leftmark}\n");
	PrCmd("\\fancyfoot[LE]{");
	PrText(mx_version);
	PrText(mx_date);
	PrCmd("}");
	PrCmd("\\fancyhead[RO]{\\thepage}\n");
	PrCmd("\\fancyhead[LO]{\\rightmark}\n");
	PrCmd("\\fancyfoot[LO]{");
	PrText(mx_author);
	PrCmd("}\n");
	*/
    } else {
	if WWWMODE PrCmd("<p><h1 align=center>");
	else PrCmd(".TL\n");
	
	PrText(mx_title);
	
	if WWWMODE PrCmd("</h1>\n\n<h2 align=center>");
	else 	PrCmd(".AU\n");
	
	PrText(mx_author);
	
	if WWWMODE PrCmd("</h2>\n\n<h3 align=center>");
	else	PrCmd("\\sp 2\n\\fBVersion \\fP");
	
	PrText(mx_version);
	
	if WWWMODE PrCmd("</h3>\n\n<h4 align=center>");
	else	PrCmd("\n");
	
	PrText(mx_date);
	
	if WWWMODE PrCmd("</h4>\n\n");
    }
    /* If it is TEXMODE do nothing, let fancy header do it */
	/* POONLAP END */
	
}

/* POONLAP BEGIN */
/*void PrUserdocTitle(void){
    ofile_puts("mx_author");
}*/
/* POONLAP BEGIN */

