
#line 6 "Index.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include	<stdio.h>
#include	"Mx.h"
#include	"MxFcnDef.h"

#define TEXMODE (textmode==M_TEX)
#define WWWMODE (textmode==M_WWW)
extern	char *	StrDup();

Itable *itable = 0;
int itable_done = 0;


void	InitIndex()
{
Itable *it;
char 	name[16];

	if( itable == 0 ){
		itable= (Itable *) Malloc(sizeof(Itable) *  M_ITABLE);
		for( it= itable; it < itable +  M_ITABLE; it++ )
			it->it_entrys= (Ientry *)
				Malloc(sizeof(Ientry) *  M_IENTRY);
	}
	
	for( it= itable; it < itable +  M_ITABLE; it++ ) {
		sprintf(name, "Index %d", it - itable);
		it->it_name= StrDup(name);
		it->it_nentry= 0;
	}
	itable[ICONT].it_name= StrDup("Table of contents");
	itable[IFRAG].it_name= StrDup("Table of fragments");
	itable[IMACRO].it_name= StrDup("Table of macro's");
}

void	IndexTable(it, name)
int	it;
char *	name;
{
	/* test it, for legal values  */

	itable[it].it_name= StrDup(name);
}

void	IndexEntry(nit, name, mod, sec)
int	nit;
char *	name;
int	mod;
int	sec;
{
	Itable *it= itable + nit;
	Ientry *ie= it->it_entrys + it->it_nentry++;

	/* test it and ie, for legal values  */
	if(name==0 ||*name==0) return;
	ie->ie_name= StrDup(name);
	ie->ie_mod= mod;
	ie->ie_sec= sec;
}

void	SortIndex()
{
Itable *it;
Ientry *ie1;
Ientry *ie2;
Ientry	iet;

	for( it= itable; it < itable +  M_ITABLE; it++ )
	for( ie1= it->it_entrys; ie1 < it->it_entrys + it->it_nentry; ie1++)
	for( ie2= ie1 + 1; ie2 < it->it_entrys + it->it_nentry; ie2++)
	if( strcmp(ie1->ie_name, ie2->ie_name) > 0) {
		iet= *ie1; *ie1= *ie2; *ie2= iet;
	}
}

void	PrCont()
{
Itable *it;
Ientry *ie;
int 	first=1;
	extern int opt_column;

	it= itable + ICONT;
	if( it->it_nentry == 0)
		return;
	itable_done = 1;

	if WWWMODE { 
		int m1=0,m2=0,m3=0,s1=0,s2=0,s3=0,i, n;
		char file[128], *b = BaseName(filename);

		/* print the simple HTML1.0 TOC in the main doc (noframes) */
		mx_out = 1;
		PrCmd("\n<hr size=5 noshade>\n");
		PrCmd("<h2>Table Of Contents</h2>\n");
		for(i=0, ie = it->it_entrys; i<it->it_nentry; i++, ie++) { 
			if (ie->ie_sec == 0) { 
				if (i) PrCmd("</ul>\n");
				PrCmd("<h3><a href=\"#mod_");
				PrNum(ie->ie_mod); PrCmd("_0_0\">"); 
				PrCmd(ie->ie_name); 
				PrCmd("</a></h3>\n<ul><li>\n");
			} else {
				PrCmd("  [<a href=\"#mod_");
				PrNum(ie->ie_mod); PrCmd("_");
				PrNum(ie->ie_sec); PrCmd("_0\">"); 
				PrCmd(ie->ie_name); PrCmd("</a>]\n");
			}
		}
		if (i) PrCmd("</ul>\n");

		/* find out where second column starts */
		n = (it->it_nentry+2)/3;
		for(i=0, ie = it->it_entrys; i<n; i++, ie++) 
			if (ie->ie_sec == 0) { 
				m2++; s2 =0;
			} else {
				s2++;
			}
		for(m3=m2, s3=s2; i<n+n; i++, ie++) 
			if (ie->ie_sec == 0) { 
				m3++; s3 = 0;
			} else {
				s3++;
			}


#line 151 "Index.mx"
		mx_out=2; sprintf(file, "%s.body.html", b);
		PrCmd("<center><table border=0>\n");
		PrCmd("<tr><th colspan=2 align=right>"); 
		PrCmd("Table Of Contents</th>");
		PrCmd("<th align=right>(");PrCmd(b);PrCmd(".mx)</th>");
		PrCmd("</tr>\n");
		for(i=0; i<n; i++) {
			ie = it->it_entrys + i;
			PrCmd("<tr><td>\n<font size=\"-1\">\n<a href=");
			PrCmd(file); PrCmd("#mod_"); 
			if (ie->ie_sec == 0 ) {
				PrNum(++m1); PrCmd("_0_0 target=a>"); 
				PrNum(m1);
				s1 = 0;
				PrCmd(" <b>");PrText(ie->ie_name);PrCmd("</b>");
			} else {
				PrNum(m1); PrCmd("_"); 
				PrNum(++s1); PrCmd("_0 target=a>"); 
				PrNum(m1); PrChr('.'); PrNum(s1); PrChr(' ');
				PrText(ie->ie_name);
			}
			PrCmd("</a></font></td><td>\n<font size=\"-1\">\n");

			if (i + n == it->it_nentry) {
				PrCmd("</font></td><td></td></tr>\n");
				continue;
			}
			ie += n;
			PrCmd("<a href=");  PrCmd(file); PrCmd("#mod_"); 
			if (ie->ie_sec == 0) {
				PrNum(++m2); 
				PrCmd("_0_0 target=a>"); 
				PrNum(m2);
				s2 = 0;
				PrCmd(" <b>");PrText(ie->ie_name);PrCmd("</b>");
			} else {
				PrNum(m2); PrCmd("_"); 
				PrNum(++s2); PrCmd("_0 target=a>"); 
				PrNum(m2); PrChr('.'); PrNum(s2); PrChr(' ');
				PrText(ie->ie_name);
			}
			PrCmd("</a></font></td><td>\n<font size=\"-1\">\n");

			if (i + n + n == it->it_nentry) {
				PrCmd("</font></td></tr>\n");
				continue;
			}
			ie += n;
			PrCmd("<a href=");  PrCmd(file); PrCmd("#mod_"); 
			if (ie->ie_sec == 0) {
				PrNum(++m3); PrCmd("_0_0 target=a>"); 
				PrNum(m3);
				s3 = 0;
				PrCmd(" <b>");PrText(ie->ie_name);PrCmd("</b>");
			} else {
				PrNum(m3); PrCmd("_"); 
				PrNum(++s3); PrCmd("_0 target=a>"); 
				PrNum(m3); PrChr('.'); PrNum(s3); PrChr(' ');
				PrText(ie->ie_name);
			}
			PrCmd("</a></font></td></tr>\n");
		}
		PrCmd("</table></center>\n");
		mx_out = 5;
		return;
	}

	/* POONLAP BEGIN */
	/* COMMENT OUT BY POONLAP
	if( TEXMODE ){
	    PrCmd("\\twocolumn[\\begin{center} \\large\\bf ");
	} else {
	    PrCmd(".SH\n");
	}
	PrText(it->it_name);
	
	if( TEXMODE ){ 
	    PrCmd("\\end{center}]\n");
	} else {
	    PrCmd("\n.LP\n");
	}
	
	if( TEXMODE ){
	    PrCmd("\\begin{flushleft}\n");
	}
	for( ie= it->it_entrys; ie < it->it_entrys + it->it_nentry; ie++ ){
	    if( ie->ie_sec == 0 ) {
		if TEXMODE PrCmd("\\makebox[3 em][l]{\\bf ");
		PrNum(ie->ie_mod);
		if TEXMODE PrCmd("}{\\bf ");
		else	PrCmd("\t");
		PrText(ie->ie_name);
		if TEXMODE PrCmd("}");
		else	PrCmd("\n");
	    } else {
		if TEXMODE PrCmd("\\hspace*{2 em}\\ ");
		if TEXMODE PrCmd("\\makebox[2 em][l]{");
		else PrCmd("\t");
		PrNum(ie->ie_mod);
		PrChr('.');
		PrNum(ie->ie_sec);
		if TEXMODE PrCmd("}{");
		else 	PrCmd(" ");
		PrText(ie->ie_name);
		if TEXMODE PrCmd("}");
		else	PrCmd("\n");
	    }
	    if TEXMODE PrCmd("\\newline\n");
	    else	PrCmd(".br\n");
	}
	if TEXMODE PrCmd("\\end{flushleft}");
	else	PrCmd(".XE\n.PX\n");
	
	if TEXMODE{
	    if (opt_column == 1) 
		PrCmd("\\onecolumn\n");
	    else
		PrCmd("\\newpage\n");
	} else PrCmd(".sp 24i\n"); /* advance to the next column */
	/*END COMMENT OUT BY POONLAP*/
	


#line 279 "Index.mx"
	/* POONLAP BEGIN */
	if(TEXMODE) {
	    /*	    PrCmd("\\tableofcontents\n\\clearpage\n");*/
	} else {
	    PrCmd(".SH\n");
	    PrCmd("\n.LP\n");
	    PrText(it->it_name);
	    
	    for( ie= it->it_entrys; ie < it->it_entrys + it->it_nentry; ie++ ){
		if( ie->ie_sec == 0 ) {
		    PrNum(ie->ie_mod);
		    PrCmd("\t");
		    PrText(ie->ie_name);
		    PrCmd("\n");
		} else {
		    PrCmd("\t");
		    PrNum(ie->ie_mod);
		    PrChr('.');
		    PrNum(ie->ie_sec);
		    PrCmd(" ");
		    PrText(ie->ie_name);
		    PrCmd("\n");
		}
		PrCmd(".br\n");
	    }
	    PrCmd(".XE\n.PX\n");
	    
	    
	    PrCmd(".sp 24i\n"); /* advance to the next column */
	    
	    
	}
	/* POONLAP END */
	
}

void	PrIndex()
{
int	it;

	if WWWMODE return;
	SortIndex();
	if TEXMODE PrCmd("\\newpage\n");
	for( it= 1; it <  M_ITABLE; it++ )
		PrItable(it);
}

void	PrItable(nit)
int	nit;
{
Itable *it;
Ientry *ie;
int first;

	it= itable + nit;
	if( it->it_nentry == 0)
		return;

	if TEXMODE PrCmd("\\twocolumn[\\begin{center} \\large\\bf ");
	else	PrCmd(".SH\n");
	PrText(it->it_name);
	if TEXMODE PrCmd("\\end{center}]");
	else PrCmd(".LP");
	PrCmd("\n");
 
	if TEXMODE PrCmd("\\begin{flushleft}\n");
	for( ie= it->it_entrys; ie < it->it_entrys + it->it_nentry; ie++ ){
		if( ie->ie_sec == 0 ) {
			if TEXMODE{
				PrText(ie->ie_name);
				PrCmd("\\dotfill ");
				PrNum(ie->ie_mod);
			} else{
/*
				if( first) {
					PrCmd(".XS "); first=0;
				} else PrCmd(".XA ");
*/
				PrCmd(".br\n");
				PrNum(ie->ie_mod);
				PrCmd("\n");
				PrText(ie->ie_name);
			}
		} else {
			if TEXMODE{
				PrText(ie->ie_name);
				PrCmd("\\dotfill ");
				PrNum(ie->ie_mod);
				PrChr('.');
				PrNum(ie->ie_sec);
			} else {
/*
				if( first) {
					PrCmd(".XS "); first=0;
				} else PrCmd(".XA ");
*/
				PrCmd(".br\n");
				PrNum(ie->ie_mod);
				PrChr('.');
				PrNum(ie->ie_sec);
				PrCmd("\n");
				PrText(ie->ie_name);
			}		
		}
		if TEXMODE PrCmd("\\newline");
		PrCmd("\n");
	}
	if TEXMODE PrCmd("\\end{flushleft}");
	
	if TEXMODE{
		if (opt_column == 1) 
			PrCmd("\\onecolumn\n");
		else
			PrCmd("\\newpage\n");
	} else	PrCmd(".XE\n");
}

