
#line 576 "Mx.mx"
/*  Copyright (C) 2002 M.L.Kersten, C.A. Van den Berg,F. Schippers, F. andres <andres@nii.ac.jp>
 *
 *  This program is part of Mx 
 *
 *  Mx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include	<stdio.h>
#include	<ctype.h>

#include	"Mx.h"
#include	"MxFcnDef.h"

#ifndef UNIX
extern	int	_trace;
#endif

int	db_flag= 0x00;
int	archived;		/* set for archived portions */
int	mode= M_TEXT;
int	opt_column= 1;
/* POONLAP BEGIN */
int     opt_userdoc = 0;
char global_author[256];
char global_version[256];
char global_title[256];
/* POONLAP END */
int	opt_hide= NO_HIDE;
int	textmode= M_TEX;
char	*opt_code;
char    *defHideText=0;

int	mx_err= 0;
char * 	mx_file= 0;
int 	mx_line= 0;
int	mx_chp =0, mx_mod=0, mx_sec= 0;
int	condSP=0;
int	codeline = 0;
char * texDocStyle = 0;

#ifdef UNIX
#define	Main	main
#endif

void	Main(int argc, char **argv)
{
int i;
char s[256];
#ifndef UNIX	
	_trace= 1;
#endif


	if( argc == 1) {
		Message("Mx version 3.0, Copyright (C) 2001 Frederic Andres <andres@nii.ac.jp> and contributors"); 
    		Message("Mx comes with ABSOLUTELY NO WARRANTY."); 
    		Message("This is free software, and you are welcome to redistribute it");
    		Message("under certain conditions; read COPYING for details.");
		Message("");
		Message("Usage: Mx <flags> <file>.mx");
		Message("\t-t\t\tProduce LaTeX document (default)");
		Message("\t-c\t\tExtract code");
		Message("\t-R<dir>\t\tSet target directory to <dir>)");
		Message("\t-S<style>\tSet LaTeX documentstyle to 'style'");
		Message("\t-s\t\tProduce nroff -ms document");
		Message("\t-1\t\tSingle column (default) ");
		Message("\t-2\t\tDouble column");
		Message("\t-H<n>\t\tSet hide level to 'n' (-H0 default)");
		Message("\t-d\t\tProduce a draft document");
		Message("\t-x <extension>\tExtract <extension> labelled code");
		Message("\t-w\t\tExtract HTML code");
		Message("\t-D<id>\t\tDefine macro 'id'");
		Message("\t-T<string>\tDefine default hide text <string>");
		/* POONLAP BEGIN */
		Message("\t-u\t\tExtract a part of document");
		Message("\t-n <Title>\tExplicitly define the name of title");
		Message("\t-a <Author>\tExplicitly define the author name");
		Message("\t-v <Version>\tExplicitly define the version");
		/* POONLAP END */
		exit(1);
	    }
	InitDef();
	OutputDir(".");
	InitIndex();


#line 676 "Mx.mx"
	i = 1;
	for(;( (i < argc) && (argv[i][0] == '-')) ; i++ ){
	    switch( argv[i][1] ){
	    case 's':	textmode= M_MS; break;
	    case 't':	textmode= M_TEX; break;
	    case 'c':	mode = M_CODE;
			break;
	    case 'x':	/* code can be extracted selectively */
			mode = M_CODE;
			if(i+1 < argc  )
				addextension(argv[++i]);
			break;
	    case 'w':	textmode= M_WWW; 
		break;
	    case 'd':	mode= M_DRAFT; break;
	    case 'g':	sscanf(argv[i], "-g%x", &db_flag); break;
	    case 'D': {
		Def *d;
		sscanf(argv[i], "-D%s", s);
		d = NwDef(Mxmacro, 0, 0);
		d->d_cmd = StrDup(s);
		d->d_blk = NULL;
	    }
		break;
	    case 'R':	
		sscanf(argv[i], "-R%s",s);
		OutputDir(s);
		break;
	    case 'S':
		sscanf(argv[i], "-S%s",s);
		texDocStyle=StrDup(s);
		break;
	    case 'H':	sscanf(argv[i], "-H%d", &opt_hide); break;
	    case '1':	opt_column= 1; break;
	    case '2':	opt_column= 2; break;
	    case 'T':	defHideText=(argv[i]+2); 
	      break;
	      /* POONLAP BEGIN */
	    case 'u':   
		opt_userdoc=1; 
		break;
	    case 'n':
		/*sscanf(argv[i], "-n%s", &global_title);*/
		strcpy( global_title, argv[++i]);
		break;
	    case 'v':
		strcpy( global_version, argv[++i]);
		break;
	    case 'a':
		strcpy( global_author, argv[++i]);
		break;
		
	      /* POONLAP END */
	    default:
		Error("Unknown flag:%s", argv[i]);
	    }
	}


	for(; i < argc 
	      && argv[i]; i++ ) {
	  MakeDefs(argv[i]);
	}
	
	if( mode & M_CODE )
	        GenCode();
	if( mode & M_DRAFT )
		GenForm();
	
	exit(mx_err ? 1 : 0);
}

Directive str2dir[]={
    "", Continue,"",
    "0",Index0,"",
    "1",Index1,"",
    "2",Index2,"",
    "3",Index3,"",
    "4",Index4,"",
    "5",Index5,"",
    "6",Index6,"",
    "7",Index7,"",
    "8",Index8,"",
    "9",Index9,"",
    "f",Ofile,"",
    "=",Mxmacro,"",
    "ifdef",Ifdef,"",
    "else",Ifndef,"",
    "endif",Endif,"",
    "a", Author,"",
    "v", Version,"",
    "t", Title,"",
    "d", Date,"",
    "*",Module,"",
    "+",Section,"",
    "-",Paragraph,"",
    "T",Qtex,"",
    "C",CCsrc,"cc",
    "i",Pimpl,"impl",
    "s",Pspec,"spec",
    "h",Cdef,"h",
    "c",Csrc,"c",
    "y",Cyacc,"y",
    "l",Clex,"l",
    "odl",ODLspec,"odl",
    "oql",OQLspec,"oql",
    "p",Prolog,"pl",
    "m",phasme,"m",
    "pil",PILcode,"pil",
    "w",WWW,"html",
    "java",Java,"java",
    "tcl",Tcl,"tcl",
    "Qnap",Qnap,"qnp",
    "cpp",cppsrc,"cpp",
    "{",InHide,"",
    "}",OutHide,"",
    /* POONLAP BEGIN */
    "U",InUserdoc,"",
    "u", OutUserdoc, "",
    /* POONLAP END */
    NULL,0,NULL};

#define NUMEXTENS (sizeof(str2dir)/sizeof(Directive))

int extcnt=0;
CmdCode extens[NUMEXTENS];
int addextension(ext)
   char *ext;
{
    extens[extcnt] = lookup(ext);
    if (extens[extcnt] > 0) {
	extcnt++;
    }
    else fprintf(stderr,"Invalid extension %s\n",ext);
}
	
int extract(dir)
   int dir;
{
   int i=0;
   if(extcnt==0) return 1;
   for(;i!=extcnt;i++)
       if(extens[i]==dir) return 1;
   return 0;
}

