
#line 5 "Print.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/


#include	<stdio.h>
#include	<stdio.h>
#include	"Mx.h"
#include	"MxFcnDef.h"
#define TEXMODE	(textmode==M_TEX)
#define WWWMODE	(textmode==M_WWW)


/* POONLAP BEGIN */
extern int userdoc;
extern int opt_userdoc; 
/* POONLAP END */


	int	pr_hide = 0;
	int	pr_hide_text = 0;
	int	pr_env= 0;
	int	pr_math= 0;
	int	pr_pos= 0;



#line 47 "Print.mx"
void	PrEnv(env)
int	env;
{
	if( Hide() ) return;

	if(env == pr_env){
		return;
	}
	
	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	switch( pr_env ){
	case E_TEXT:
		if TEXMODE ofile_printf("}");
		break;
	case E_CODE:
		if TEXMODE ofile_printf("\\end{verbatim}\\normalsize}\n");
		else if WWWMODE ofile_printf("</font></pre>\n");
		break;
	case E_CMD:
		break;
	}
	pr_env= env;
	pr_pos= 0;
	switch( pr_env ){
	case E_TEXT:
		if TEXMODE ofile_printf("{");
		break;
	case E_CODE:
		if TEXMODE ofile_printf("{\\codesize\\begin{verbatim}\n");
		else if WWWMODE ofile_printf("<pre><font size=\"-1\" color=\"%s\">", code_color);
		break;
	case E_CMD:
		break;
	}
}



#line 88 "Print.mx"

void	PrRef(mod, sec)
int	mod;
int	sec;
{
	/* POONLAP BEGIN */
    if( !DoPrint() ) return;
	    /* POONLAP END */
    
	PrChr('[');
	if( mod != 0 )
		PrNum(mod);
	else
		PrChr('?');
	if( sec != 0 ){
		PrChr('.');
		PrNum(sec);
	}
	PrChr(']');
}

void	PrNum(n)
int	n;
{
	if( Hide() ) return;

	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	ofile_printf("%d", n);
}

void PrTxt(s)
    char * s;
{
    void MathOn();
    void MathOff();

    char c = *s;
    	/* POONLAP BEGIN */
	if( !DoPrint ) return;
	    /* POONLAP END */

    while((c = (*s++)))
	switch(c){
	case '\t':
	case '\n':
	case ' ':
	    MathOff();ofile_printf("%c", c);	
	    break;
	case '~':
		MathOff(); ofile_printf("\\~\\,");
		break;
	case '[':
	case ']':
		MathOff(); ofile_printf("{%c}", c);
		break;
	case '&':
	case '%':
	case '$':
	case '#':
	case '_':
	case '{':
	case '}':
		MathOff(); ofile_printf("\\%c", c);
		break;
	default:
		MathOff(); ofile_printf("%c", c);
		break;
	case '\\':
		MathOn(); ofile_printf("\\backslash");
		break;
	case '/':
	case '|':
	case '-':
	case '+':
	case '<':
	case '>':
	case '*':
	case '=':
		MathOn(); ofile_printf("%c", c);
		break;
	}
}


void	PrStr(s)
char *	s;
{
	char *	c;
	void MathOff();
	
	if( Hide() ) return;

	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	for( c = s; *c != '\0'; c++ ){
		if( (c[0] == '\\') && (c[1] == '@') )
			c++;
		PrChr(*c);
	}
	MathOff();
}

extern int codeline;

PrCodeline()
{
	if (WWWMODE && (pr_pos<8)) {
		ofile_printf("<font color=\"8FBC8F\" size=\"-2\">%6d  </font>", codeline);
		pr_pos = 8;
	}
}

void	PrChr(c)
char	c;
{
	void MathOff();
	void MathOn();
	extern int opt_column;
	int start_pos = pr_pos;

	if( Hide() ) return;

	/* POONLAP BEGIN */
	if( !DoPrint() ) return;
	    /* POONLAP END */
	/* administer pr_pos and codeline */
	switch( c ){
	case'\t':
	    do {
	        pr_pos++; 
	    } while( (pr_pos % (8 / opt_column)) != 0 );
	    break;
	case '\n':
	    codeline++; pr_pos= 0;
	    break;
	default:
	    pr_pos++;
	}

	if (WWWMODE || (pr_env & E_TEXT) == E_TEXT ) {
	    switch( c ){
	    case '\n':
	    case '\t':
	    case ' ':
		MathOff();
		ofile_putc(c);
		break;
	    case '~':
		MathOff();
		if TEXMODE ofile_printf("\\~\\,");
		else	ofile_printf("%c",c);
		break;
	    case '[':
	    case ']':
		MathOff();
		if TEXMODE ofile_printf("{%c}", c);
		else	ofile_printf("%c",c);
		break;
	    case '&':
		if WWWMODE {
		    ofile_puts("&#38;");
		    break;
		}
	    case '%':
	    case '$':
	    case '#':
	    case '_':
	    case '{':
	    case '}':
		MathOff();
		if TEXMODE ofile_printf("\\%c", c);
		else	ofile_printf("%c",c);
		break;
	    case '\\':
		MathOn();
		if TEXMODE	ofile_printf("\\backslash");
		else if WWWMODE ofile_putc('\\'); 
		else	        ofile_printf("\\e");
		break;
	    case '<':
		if WWWMODE {
			ofile_puts("&#60;");
			break;
		}
	    case '>':
		if WWWMODE {
			ofile_puts("&#62;");
			break;
		}
	    case '/':
	    case '|':
	    case '-':
	    case '+':
	    case '*':
	    case '=':
		MathOn();
		ofile_putc(c);
		break;
	    case '"':
		if WWWMODE {
		    ofile_puts("&#34;");
		    break;
		}
	    default:
		MathOff();
		ofile_putc(c);
		break;
	    } 
  	    return;
	}

	if ((pr_env & E_CODE) == E_CODE ){
	    PrCodeline();
	    switch(c){
	    case'\t':
		while(start_pos++ < pr_pos) ofile_putc(' ');
		break;
	    case '\\':
		ofile_puts(TEXMODE?"\\e":"\\");
		break;
	    default:
		ofile_putc(c);
	    }
	    return;
	}

	if ((pr_env & E_CMD) == E_CMD){
	    switch(c){
	    default:
		ofile_putc(c);
		break;
	    }
	}
}

void	MathOn()
{
	if TEXMODE
	if( pr_math == 0 )
		ofile_printf("${\\scriptstyle");
	pr_math= 1;
}

void	MathOff()
{
	if TEXMODE
	if( pr_math == 1)
		ofile_printf("}$");
	pr_math= 0;
}

void	HideOn()
{
	pr_hide++;
}



void	HideText()
{
	pr_hide_text = 1;
}

void	HideOff()
{
    extern char *defHideText;

    if( (pr_hide == opt_hide) && !pr_hide_text && (defHideText != (char *)0))
	ofile_printf(defHideText);
    pr_hide--;
    pr_hide_text = 0;
}

/* Is in hide mode or not */
int	Hide()
{
	if( archived) return 1;
	return (((opt_hide == NO_HIDE) && pr_hide_text)||
		((pr_hide != opt_hide) && pr_hide_text)||
		((pr_hide >= opt_hide)&&(opt_hide != NO_HIDE)&&!pr_hide_text));
}

/* POONLAP BEGIN */


#line 378 "Print.mx"
int DoPrint(void){
    if( opt_userdoc==0 ){
	return 1;
    } else if( userdoc==1 ){
	return 1;
    } else {
	return 0;
    }
}
/* POONLAP END */


