
#line 5 "Sys.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include	<stdio.h>
#include	<ctype.h>
#include 	<stdlib.h>
#include 	<string.h>

#include	"Mx.h"
#include	"MxFcnDef.h"
#include 	<varargs.h>    /* va_alist.. */

int mx_out = 1;

/* VARARGS */
ofile_printf(va_alist)
va_dcl
{
	char *format;
        va_list ap; 
        va_start (ap); 
	format = va_arg(ap, char*);
	if (mx_out&1) vfprintf(ofile, format, ap);
	if (ofile_index && (mx_out&2)) vfprintf(ofile_index, format, ap);
	if (ofile_body && (mx_out&4)) vfprintf(ofile_body, format, ap);
        va_end (ap); 
}

ofile_puts(s)
char* s;
{
	if (mx_out&1) fputs(s, ofile);
	if (ofile_index && (mx_out&2)) fputs(s, ofile_index);
	if (ofile_body && (mx_out&4)) fputs(s, ofile_body);
}

ofile_putc(c, fp)
char c;
FILE *fp;
{
	if (mx_out&1) fputc(c, ofile);
	if (ofile_index && (mx_out&2)) fputc(c, ofile_index);
	if (ofile_body && (mx_out&4)) fputc(c, ofile_body);
}


char *	Malloc(size)
int	size;
{
char *	buf;

	if( (buf= malloc((unsigned) size)) == 0 )
		Fatal("Malloc", "Not enough memory");
	return buf;
}

void	Free(ptr)
char *	ptr;
{
/*
	free(ptr);
 */
}

char *	StrDup(str)
char *	str;
{
	return strcpy(Malloc(strlen(str) + 1), str);
}

/*VARGARGS2*/
void	Fatal(fcn, msg, a1, a2, a3, a4, a5)
char *	fcn;
char *	msg;
long 	a1, a2, a3, a4, a5;
{
	fprintf(stderr, "Mx(%s):", fcn);
	fprintf(stderr, msg, a1, a2, a3, a4, a5);
	if( mx_file )
		fprintf(stderr, "[%s:%d]", mx_file, mx_line);
	fprintf(stderr, ".\n");
	exit(1);
}

/*VARGARGS1*/
void	Error(msg, a1, a2, a3, a4, a5)
char *	msg;
long 	a1, a2, a3, a4, a5;
{
	fprintf(stderr, "Mx:");
	fprintf(stderr, msg, a1, a2, a3, a4, a5);
	if( mx_file )
		fprintf(stderr, "[%s:%d]", mx_file, mx_line);
	fprintf(stderr, ".\n");
	mx_err++;
}

/*VARGARGS1*/
void	Message(msg, a1, a2, a3, a4, a5)
char *	msg;
long 	a1, a2, a3, a4, a5;
{
	fprintf(stderr, msg, a1, a2, a3, a4, a5);
	if( mx_file )
		fprintf(stderr, "[%s:%d]", mx_file, mx_line);
	fprintf(stderr, ".\n");
}

