
#line 6 "Tex2Html.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/


#include        <stdio.h>

/* WHAT: first we allowed users to type LaTex article-style code inside 
 * documents. But now we want to generate HTML output. What do we do? 
 * Translate all the LaTeX codes again.. We support also simple LaTeX tables,
 * bibtex citations, labels and refs, and epsf imagery.
 * No \defs, \newcommands, or \figures, please..
 * This is an opportunistic set of routines. 
 * You can compile a utility with the -DSTANDALONE flag.
 * STATUS: dirty hack^3
 * AUTHOR: The Spagetti Corp, Ltd. 
 */

#define bzero(p,l) memset( p,0,l )

#ifdef STANDALONE
	char *outputdir = ".";
	FILE* ofile = stdout;
	PrChr(c) 
        char c;      
	{
		if (c=='&')        ofile_puts("&#38;");
                else if (c == '"') ofile_puts("&#34;");
                else if (c == '<') ofile_puts("&#60;");
                else if (c == '>') ofile_puts("&#62;");
                else ofile_putc(c);
	}
#else
#include        "Mx.h"
#include        "MxFcnDef.h"
              extern FILE* ofile;
              extern char *outputdir;
#endif

#define TYPE_HLINE  	0	
#define TYPE_MBOX	32
#define TYPE_ITEM	33
#define TYPE_FOOTNOTE   36
#define TYPE_WWW 	37	
#define TYPE_THANKS     38
#define TYPE_SECTION	39
#define TYPE_TITLE	42
#define TYPE_CITE	46
#define TYPE_BIB	47
#define TYPE_REF	48
#define TYPE_LABEL	49
#define TYPE_TABULAR	52
#define TYPE_TT		54
#define TYPE_DESC	59
#define TYPE_VERBATIM	60
#define TYPE_TINY       62
#define TYPE_HUGE       71

char *keyword[] =  {
	"hline", "rule", "newline", "newpage", "clearpage", "backslash", 
	"bullet", "parallel", "cdot", "cdots", "ldots", "pounds", "copyright", 
	"S", "not", "P", "times", "ae", "AE", " ","skip", "bigskip", "leq", 
	"geq", "div", "pm", "ll", "gg", "mid", "wedge", "vee", "sim", "mbox", 
	"item", "indent", "itemindent", "footnote", "www", "thanks", "section", 
	"subsection", "subsubsection", "title", "date", "author", 
	"caption", "cite", "bibliography", "ref", "label", "epsffile", 
	"epsfbox", "tabular", "array", "tt", "em", "bf", "center", "itemize", 
        "description", "verbatim", "enumerate", "tiny", "scriptsize", 
        "footnotesize","small", "normalsize", "large", "Large", "LARGE",
        "huge", "Huge", 0 };

char *translation[] =  {
	"<hr noshade size=3>\n", "<hr noshade size=3>\n", "<br>", "<p>\n", 
	"<p>", "\\", "<b>&#183;</b>", "||", "&#183;", "&#183;&#183;", "..", 
	"&#163;", "&#169;", "&#167;", "&#172;", "&#182;", "&#215;", "&#230;", 
	"&#189;", "&#160;", "<br><br>", "<br><p><br>", "&#60;=", "&#62;=", 
	"&#247;", "&#177;", "&#60;&#60;", "&#62;&#62;", "|", 
	" <font size=\"-1\"><i>and</i></font> ",
	" <font size=\"-1\"><i>or</i></font> ", "~", "", "<li>", 
	"&#160;&#160;&#160;&#160;", "&#160;&#160;&#160;&#160;", 
	"font size=\"-2\"", "font size=\"-1\"", "h2", "h3", "h4", "a href=\"", 
	"font size=\"+3\"", "font size=\"+2\"", "font size=\"+1\"", "i", 
	"font size=\"-1\"", "", "", "", "", "", "table", "table", "tt", "i", 
        "b", "center", "ul", "dl", "pre", "ol", "-4", "-2", "-1", "-1", "-1", 
        "+0", "+1", "+2", "+3", "+4", 0 }; 

typedef struct {
		char *str;
		int len;
		int nested[512];
		int nchildren;
	} texblock_t;

texblock_t tb[1000];
int     nblocks = 0;
char    latexstr[100000] = {0};
char   *latexend = latexstr;
char   *table_center = "center";
char   *table_left = "left";
char   *table_right = "right";
char   *table_empty = "";
char   *table_columns[20];
int    table_column, printed_column;
int    table, indesclist, math;
char   bibtexfile[256] = { 0 };
char   *ref_names[1000];
int    nrefs=0;
char   refbuf[10000] = {0},*refend=refbuf;

/* table for html special characters */
typedef int larr[6];
larr	ltab[256] = { 0 };

void initltab(lt, p1, p2, p3, p4, p5, p6)
int lt, p1, p2, p3, p4, p5, p6;
{
	if (p1) { ltab[lt][0]=p1; ltab[lt-'A'+'a'][0] = p1+32; }
	if (p2) { ltab[lt][1]=p2; ltab[lt-'A'+'a'][1] = p2+32; }
	if (p3) { ltab[lt][2]=p3; ltab[lt-'A'+'a'][2] = p3+32; }
	if (p4) { ltab[lt][3]=p4; ltab[lt-'A'+'a'][3] = p4+32; }
	if (p5) { ltab[lt][4]=p5; ltab[lt-'A'+'a'][4] = p5+32; }
	if (p6) { ltab[lt][5]=p6; ltab[lt-'A'+'a'][5] = p6+32; }
}


#line 146 "Tex2Html.mx"
int bib_insert(str)
char *str;
{
	int i;
	for(i=0; i<nrefs; i++) 
		if (!strcmp(str,ref_names[i])) return i+1;
	ref_names[nrefs] = refend;
	while(*refend++ = *str++);
	return ++nrefs;
}


#line 159 "Tex2Html.mx"
char *bib_entry(str,buf)
char *str, *buf;
{
	static char entry[1000];
	char *e=entry, *p = (char*) strstr(buf,str);
	int inword = 0, endchar='"';

	if (!p || !*p) return 0;
	p = (char*) strchr(p, '=');
	if (!p || !*p) return 0;
	for(p++; p && *p && isspace(*p); p++); 
	if (!p || !*p) return 0;
	if (*p == '"') p++;
	else endchar=',';
	for(;*p && ((*p!=endchar) || p[-1]=='\\'); p++) {
		if (isspace(*p)) {
			if (inword) *e++ = ' ';
			inword = 0;
		} else { 
			*e++ = *p;
			inword = 1;
		}
	}
	/* cut off spaces and dots at the end, we do formatting ourselves */
	while(e>entry && (isspace(e[-1]) || (e[-1] == '.'))) e--;
	*e = 0;
	return entry;
}


#line 190 "Tex2Html.mx"
int bib_look(str,buf,hit)
char *str,*buf;
char **hit;
{
	int len = strlen(str), blen=0;
	char *p1 = buf, *p2;

	while ((p1 = (char*) strstr(p1+len,str)) && 
	         !(isalnum(p1[-1]) || (p1[len]==',') || isspace(p1[len])));
	if (!p1) return 0;
	while(*++p1 && *p1 != '\n');
	*hit = p1; 
	if (p2= (char*) strstr(p1,"\n}")) blen=p2-p1;
	return blen;
}


#define output(s,p) { sprintf(out,s,p); out+=strlen(out); }


#line 211 "Tex2Html.mx"
void bib_print()
{
	char inbuf[100000], oubuf[100000], *out=oubuf; 
	char *p,*www, *hit;
	FILE *fp;
	int nchars,i,l;

	if ((fp=fopen(bibtexfile, "r")) == 0) {
		ofile_printf(stderr, "latex2html: cannot open %s.\n", bibtexfile);
		return;
	}
	*bibtexfile = 0;
	nchars = fread(inbuf,1,100000,fp);
	fclose(fp); inbuf[nchars] = 0;

	output("\\skip{\\Large References}{\\small\\begin{description}\n", 0);
	for(i=0; i<nrefs; i++) {
		if (!(l=bib_look(ref_names[i],inbuf,&hit))) 
			continue;
		hit[l]=0; /* temporarily close inbuf at hit end */
		output("\\item[[%d]]\n", i+1);
		if (www=bib_entry("www", hit)) 
			output("\\www[%s]{", www);
		if (p=bib_entry("author", hit)) 
			output("%s: ", p);
		if (p=bib_entry("title", hit)) 
			output("{\\bf %s}", p);
		output(". ", 0);
		if (p=bib_entry("booktitle", hit)) {
		    output("In {\\em %s}", p);
		} else if (p=bib_entry("journal", hit)) {
		    output("{\\em %s} ", p);
		    if (p=bib_entry("volume", hit)) 
			output(", %s", p);
		    if (p=bib_entry("number", hit))
			output("(%s)", p);
		}
		if (p=bib_entry(", pages",hit,l))
			output(", pages %s", p);
  		if ((p=bib_entry("publisher", hit)) ||
                    (p=bib_entry("institution", hit))) 
			output(". %s", p);
		if (p=bib_entry("month", hit)) {
			if (!strcmp(p,"jan")) output(", Januari", 0)
			else if (!strcmp(p,"feb")) output(", Februari", 0)
			else if (!strcmp(p,"mar")) output(", March", 0)
			else if (!strcmp(p,"apr")) output(", April", 0)
			else if (!strcmp(p,"may")) output(", May", 0)
			else if (!strcmp(p,"jun")) output(", June", 0)
			else if (!strcmp(p,"jul")) output(", July", 0)
			else if (!strcmp(p,"aug")) output(", August", 0)
			else if (!strcmp(p,"sep")) output(", September", 0)
			else if (!strcmp(p,"oct")) output(", October", 0)
			else if (!strcmp(p,"nov")) output(", November", 0)
			else if (!strcmp(p,"dec")) output(", December", 0)
			else output(",", 0);
			if (p=bib_entry("year", hit))
				output(" %s", p);
		}
		output(".", 0);
		if (www) output("}", 0);
		hit[l]=' '; /* reopen inbuf */
	}
	output("\n\\end{description}}\n", 0);
	*out=0; latex2html(oubuf,1,1);
}


char *PrintChar(s)
char *s;
{
	if (*s == '@') {
	    int index = 0;
	    switch(s[1]) {
	    case '`': index = 1;
	    case ':': case '[':
		*s++ = 0; *s++ = 0; 
		while(*s && *s != '@') {
			ofile_putc(*s); *s++ = 0;
		}
  		*s = 0;
		if (index && isdigit(s[1])) 
			*++s = 0; 
	        return s;
	    }
	}
	PrChr(*s); *s = 0;
	return s;
}

int new_token(str) 
char *str;
{
	int i = nblocks++;
	tb[i].nchildren = 0;
	tb[i].str = str;
	return i;
}



#line 313 "Tex2Html.mx"
char *table_format(s)
char **s;
{
	char *format=0, *p1;
	for(p1 = *s; p1 < latexend && *p1; p1++) {
		char c = *p1;
		*p1 = 0; /* nullify */
		if (c == 'l') {
		    format = table_left;
		} else if (c == 'c') {
		    format = table_center;
		} else if (c== 'r') {
		    format = table_right;
		} else if (c == 'p') {
		    while(isspace(*++p1));
		    if (*p1) continue;
		    for(p1++;*p1;p1++) *p1= 0; /* nullify */
		    format = table_left;
		} else continue;
		break;
	}
	*s = p1;
	return format;
}



#line 341 "Tex2Html.mx"
char *skip_opt(ptr) 
char **ptr;
{
	char *t,*s = *ptr, blk;
	while ((!*s) || isspace(*s)) 
		if (*s++ == '\n') return *ptr;
	if (*s != '[') return *ptr;
	t = ++s;
     	for(blk=1; blk; s++) {
	    if (s[-1] != '\\' && s[-1] != '@') {
		if (*s == ']') blk--;
		else if (*s == '[') blk++;
	    }
	} 
	s[-1] = 0; *ptr = s-1;
	return t;
}

/* skip the {XXX} param after a LaTex command. return the end position.
 * this routine got complicated through the presence of verbatim blocks,
 * (then: readonly==1), and the '\begin{XXX}'-to-'\XXX' translation we
 * do here (though we shouldn't), *only* at block-start, not block-end. 
 */
char *skip_param(s,blockstart,readonly)
char *s;
int blockstart;
int *readonly;
{
	char *t;
	while (*s && isspace(*s)) 
		s++;
	if (*s != '{') 
		return s;
	if (blockstart && !*readonly) 
		*s = '\\';
	t = ++s;
	while (*s && ((*s != '}') || (s[-1]=='\\'))) 
		s++;
	if (blockstart && !*readonly) 
		*s = ' ';
	if ((*readonly!=blockstart) && !strncmp(t,"verbatim",8))
		*readonly=blockstart;
	if (!(blockstart || *readonly)) 
		bzero(t-1, 2+s-t);
	return s+1;
}

/* Walk through the LaTeX text, discovering all nested blocks.
 * This structure is saved in the 'tb[]' table.
 * Blocks are marked by '{' ... '}' or '\begin{XXX}' .. '\end{XXX}'.
 * For simplicity, '\begin{XXX}' ..'\end{XXX}' blocks get converted
 * to '{\XXX ... }' blocks.
 */
char *find_blocks(vb, p1, t)
int  vb;
char *p1;
int t;
{
    char c,*p2;
    int escaped = 0;

    while(c=*p1) {
	int i = t;
	if (c == '{') {
	    if (escaped) {
		p1[-1] = ' ';
	    } else {
		if (vb==0) *p1 = 0;
		tb[t].nested[tb[t].nchildren++] = i = new_token(++p1); 
		p2 = find_blocks(vb, p1, i);
		tb[i].len = p2-p1; 
		p1 = p2;
		continue;
	    }
	} else if (c == '}') {
	    if (escaped) {
		p1[-1] = ' ';
	    } else {
		if (vb==0) *p1 = 0;
		return ++p1;
            }
	} else if (c == '\\') {
	    int vb2 = vb;
	    if (strncmp(p1+1, "begin",5)==0) {
		if (vb==0) bzero(p1,6);
		tb[t].nested[tb[t].nchildren++] = i = new_token(p1+=6); 
		p1 = skip_param(p1,1,&vb2);
		p2 = find_blocks(vb2,p1, i);
		tb[i].len = p2-p1; 
		p1 = p2;
		continue;
	    } else if (strncmp(p1+1, "end",3)==0) {
		p2 = skip_param(p1+4,0,&vb2);
		if ((vb==0) || (vb2==0)) bzero(p1,4);
		return p2;
	    } else if (!escaped) {
 		p1++; escaped=1;
		continue;
	    }
	}
	p1++; escaped=0;
    }
    return p1;
}

#define STACK(s,buf)	{int l=strlen(s); *buf -= l; strncpy(*buf,s,l);}

/* parse a LaTex string (between 'p1' and 'p2') and echo the translation
 * into HTML on the fly. Closing codes of block-operands, that are to be
 * placed at block-end, are STACK-ed in 'buf', 2b flushed later.
 */
int translate_text(p1,p2,stack,nextstack)
char *p1;
char *p2;
char **stack;
char *nextstack;
{
    char c, str[256], *opt_start, *opt_end, *p;
    int i, k, len;
    nextstack[0] = 0;

    while(p1 < p2) {
	/* FIRST: table hack!! */
	if (table && (printed_column <= table_column)) { 
		char *p3, *p4 = p2+1, *p5 = table_columns[table_column];
		int width = 1;
		/* just bypass the whole philosophy of this program now */
		for(p3=p1; isspace(*p3); p3++);
		if (strncmp(p3,"\\multicolumn",12)==0) {
			sscanf(p2, "%d",&width);
			for(p4=p2; *p4; p4++); /* skip width */ 
			for(p4+=2; p1=table_format(&p4); p4++) p5 = p1;
			bzero(p2,p4-p2); p1 = p2;
			table_column += width-1;
			printed_column += width-1; 
		} 
		ofile_printf("<td align=%s colspan=%d><font size=\"-1\">\n",
			p5, width);
		printed_column++;
	}

	/* non-escaped characters in sight */
	if (*p1 != '\\') {
		switch(*p1) {
		case '~': ofile_puts("&#160"); break;
		case '$': if (math) {
mathoff:			math=0; ofile_puts("</i>");
			  } else {
mathon:				math=1; ofile_puts("<i>");
			  } break;
		case '&': if (table) {
			  	/* tab code in a table */
			  	ofile_printf( "</font></td>\n");
			  	table_column++; break;
			  } 
		case '\'': 
		case '-': if (p1[1]==p1[0]) {
				ofile_putc(*p1++); 
				break;
			  }
		default:
			/* echo this plain and normal character. */
			if (*p1) p1 = PrintChar(p1);
		}
		p1++;
	    	continue;
        }

	/* do short codes first */
	c = *++p1; k = 0;
	switch(c) {
	case ']':  goto mathoff;
	case '[':  goto mathon;
	case '\\': /* LaTeX newline */
	    	   if (table) {
			ofile_printf( "</font></td></tr><tr>\n");
			table_column = printed_column = 0;
	    	   } else ofile_puts("<br>");
	    	   p1++; continue;
	case 'c':  if (p1[1]) break; /* require block: disallow e.g. '\cite' */
		   k++;
	case '`':  k++;
	case '\'': k++;
	case '^':  k++;
	case '~':  k++;
	case '"':  /* handle TeX's escaped chars here */
		   while((++p1 < latexend) && ((!*p1) || (*p1 == '\\')));
		   if (k = ltab[*p1][5-k]) ofile_printf( "&%d;", k); 
		   *p1 = 0; /* nullify */
	default:   if (isprint(*p1)) break;
		   /* ignore nonprintable chars */
		   p1++; continue;
	}

	/* so, this must be a LaTeX '\XXX[YYY]{ZZZ}' keyword. */
	for(len=1; p1+len<p2; len++) 
		if ((!p1[len]) || isspace(p1[len]) || (p1[len]==',') || 
		    (p1[len]=='[') || (p1[len]=='*') || 
		    (p1[len]=='$') || p1[len]=='\\') break;

	for(i=TYPE_HUGE; i >= TYPE_HLINE; i--) 
		if ((strncmp(p1, keyword[i],len)==0) && 
                    (len == strlen(keyword[i]))) break;
	if (p1[len]=='*') len++; /* 'XXX*' equals to 'XXX' */ 
	p = p1; p1 += len;
	opt_start = skip_opt(&p1); /* parse the '[YYY]' part */
	opt_end = p1+1;



#line 552 "Tex2Html.mx"
	if (i < 0) {
		/* unknown command. */
		if ((len==1) || !isalnum(c))  {
			p1 = p+1; PrChr(*p); /* some escaped character */
		} else if (math) {
			/* in mathmode, we treat it as a predicate */
			ofile_puts(" <font size=\"-1\"><i>");
			for(i=0; i<len; i++) PrChr(p[i]);
			ofile_puts("</i></font> ");
		} else {
			/* scientific approach: ignore unexplicable phenomena */
			char *p3 = p1; 
			while(p3 < p2 && isspace(*p3++));
			/* also ignore following parameter blocks? */
			if (p3 == p2) return 0; 
		}
	} else if (i < TYPE_FOOTNOTE) {
		/* a simple code: 1-1 translation possible. */
		if (table && (i == TYPE_HLINE)) {
			if (printed_column > 1) {
				ofile_printf( "</font></td>\n");
				if (table > printed_column) {
					ofile_printf(
		"<td colspan=%d><font size=\"+1\"> </font></td>\n", 
						table-printed_column);
				}
				ofile_printf( "</tr><tr>\n");
				printed_column=0; 	
			}
			table_column = 0;
		} else if (math && i == TYPE_MBOX)  {
			ofile_puts("</i>");
			return 3;
		} else if (indesclist && (i == TYPE_ITEM)) {
			char stackbuf[129], *stackptr=stackbuf+128;
			ofile_puts("<dt><b>");
			stackbuf[128] = 0;
			translate_text(opt_start,opt_end,&stackptr,nextstack);
			while(opt_start < opt_end) *opt_start++ = 0;
			ofile_puts(stackptr);
			ofile_puts("</b>\n<dd>");
		} else {
			ofile_puts(translation[i]);
		}
	} else if (i < TYPE_CITE) {
		/* sections and headers: parameter block is translated next. */
		while(isspace(*p1)) p1++;
		if (!*p1) { 
		    if (i >= TYPE_TITLE) ofile_puts("<center>");
		    if (i == TYPE_WWW) {
		        ofile_printf( "<a href=\"%s\">", opt_start);
		        sprintf(nextstack, "</a>\n",p1);
		    } else {
		        ofile_printf( "<%s>", translation[i]);
			if (i <= TYPE_THANKS) {
			    if (i == TYPE_THANKS) ofile_puts("<br>[");
			    else ofile_puts("[");
			    sprintf(nextstack, "]</%s>", translation[i]); 
			} else if (i >= TYPE_TITLE) {
			    sprintf(nextstack,"</%s></center>",translation[i]);
			} else {
			    sprintf(nextstack,"</%s><p>",translation[i]);
			}
		    }
		}
	} else if (i < TYPE_TABULAR) {
		/* 1 simple param: labels, citations, bibliography, and epsf */
		char *p3 = p2, *p4;
		while(p3<latexend && !*p3) p3++;
	        if (i >= TYPE_BIB) { /* get a label or bibname */
			extern char* inputdir;
			for(p4=str; *p4++ = *p3; *p3++ = 0);
			if (i == TYPE_BIB) {
				strcpy(p4-1, ".bib");
				strcpy(bibtexfile,str);
                        } else if (i == TYPE_LABEL) {
                                ofile_printf( "<a name=\"%s\"></a>",str);
                        } else if (i == TYPE_REF) {
                                ofile_printf(
                                "<a href=\"#%s\">&#60;&#167;&#62;</a>", str);
			} else {
				char cmd[512], file[512];
				FILE *fp;
                                sprintf(file, "%s/%s",outputdir,str);
                                if (p4=strchr(file+strlen(outputdir),'.'))
                                    *p4=0;
				strcat(file, ".gif");
				if (fp=fopen(file,"r")) {
				    fclose(fp);
				} else { 
				    /* translate eps to 500x500-bounded gif */
				    sprintf(cmd, "epstogif %s %s 500 500\n",
						str, file);
				    system(cmd);
				}
				ofile_printf( "<p><img src=\"%s\" align=center><br>",file+strlen(outputdir)+1);
			}
			continue;
		}
		/* LaTeX reference */
		ofile_putc('[');
		for(p4 = p3, i=-1; p3<latexend && *p3; p3++) {
			if ((*p3 == ',') || isspace(*p3)) {
			    if (p3 > p4) {
				*p3 = 0; if (i>=0) ofile_putc(',');
				ofile_printf( "%d", i=bib_insert(p4));
			    }
			    p4 = p3+1;
			} 
		}
		*p3 = 0; if (i>=0) ofile_putc(',');
		ofile_printf( "%d]", bib_insert(p4));
		bzero(p2,p3-p2);
	} else if (i < TYPE_TT) {
		/* tables and arrays */
		char *format;
		while(*p1) p1++;
		for(p1++; format = table_format(&p1); p1++)
			table_columns[table++] = format;
		for(i=table; i<20; i++) 
			table_columns[i] = table_empty;
		ofile_printf( "\n<table border=2>\n<tr>\n");
		printed_column = table_column = 0;
		if (table>1) {
			sprintf(str, "\n+</font></td><td colspan=%d align=right><font size=\"-1\">+</font></td></tr>\n</table>\n", table-1);
			STACK(str, stack);
		} else {
			STACK("\n===</font></td></tr>\n</table>\n", stack);
		}
	} else {
		/* a block code: 1 start-code now, stack the end-code. */
		if (i < TYPE_TINY) {
			sprintf(str, " <%s>",translation[i]);
		} else {
			sprintf(str, " <font size=\"%s\">",translation[i]);
		}
		ofile_puts(str);
		str[0]='<'; str[1]= '/'; STACK(str,stack);
		if (i == TYPE_VERBATIM) {
			/* enter verbatim mode: echo the entire block. */
			while(isspace(*p1)) p1++;
			while(p1 < latexend && *p1) {
				p1 = PrintChar(p1); p1++;
			}
			break;
		} else if (i == TYPE_DESC) indesclist = 1;
	}
    }
    return 1;
}

/* Walk through the LaTeX structure recursively, outputting block by block.
 * At the end of a block, the stack-buffer -- containing closing codes of 
 * opened blocks -- is flushed.
 */
void subst_blocks(t,initstack)
int t;
char *initstack;
{
	char *p1 = tb[t].str, *p2;
	char nextstack[1000], stackbuf[1001], *stackptr=stackbuf+1000;
	int i, save_tab = table;
	int dl = indesclist, printing = 1;

	stackbuf[1000] = 0;
	STACK(initstack,(&stackptr));	

	for(i=0; i<tb[t].nchildren; i++) {
		int nextblock = tb[t].nested[i];
		p2 = tb[nextblock].str;
		if (!printing) { 
	                /* keep ignoring blocks if only whtspce in between */ 
			char *p3=p1;
			while(p3<p2 && isspace(*p3++));
			if (p3<p2) printing=1;
		}
		printing &= translate_text(p1,p2,&stackptr,nextstack);
		p1 = p2+tb[nextblock].len;
		if (printing) {
 			subst_blocks(nextblock,nextstack);	
			if (printing&2) { /* was doing a mbox in mathmode? */
				ofile_puts("<i>");
			}
		}
	}
	translate_text(p1,tb[t].str+tb[t].len,&stackptr,nextstack);
	table = save_tab; indesclist = dl;

	ofile_puts(stackptr);
}


/* The main routine. it can be called repeatedly, aggregating consecutive
 * LaTeX blocks, until 'flush' is set to 1.
 * LaTeX comment codes (lines starting with a '%') are filtered here.
 */
latex2html(s,init,flush)
char *s;
int init,flush;
{
	if (!s) return;
	if (init) {
		initltab('A', 0, 192, 193, 194, 195, 196);
		initltab('C', 199,0,   0,   0,   0,   0 );
		initltab('E', 0,  200, 201, 202, 0,   203);
		initltab('I', 0,  204, 205, 206, 0,   207);
		initltab('N', 0,  0,   0,   0,   209, 0 );
		initltab('U', 0,  217, 218, 219, 0,   220);
		initltab('Y', 0,  221, 0,   0,   0,   0 );
		latexstr[0] = 0;
		latexend = latexstr;
		math = indesclist = nblocks = 0;
		table = table_column = printed_column = 0;
	} else {
		*latexend++ = '\n';
	}
	while(*s) {
		char *t = s;
		while(*t && isspace(*t)) t++;
		if (*t == '%') for(s=t; *s && *s != '\n'; s++);
		else do {
			*latexend++ = *s;
		} while((*s++ != '\n') && *s);
	}
	if (flush) {
		int i = new_token(latexstr);
		tb[i].len = latexend-latexstr; 
		*latexend = 0;
		find_blocks(0,latexstr,i); 
		subst_blocks(i,""); 
	}
}



#ifdef STANDALONE
int main(argc,argv) 
int argc; char **argv;
{
    char buf[100000], oname[1024]; 
    int nchars = 0;
    FILE *fp= (argc==0)?stdin:fopen(argv[1],"r");

    if (argc > 1) {
	int len = strlen(argv[1]);
	strcpy(oname,argv[1]);
	strcpy(oname+len-(strncmp(oname+len-4,".tex")?0:4),".html");
        ofile = fopen(oname,"w");
	outputdir = argv[2];
    } 
    if (!(fp || ofile)) return 1;

    ofile_printf("<HTML>\n<HEAD>\n");
    ofile_printf("<TITLE>Html from %s</TITLE>\n",(argc==0)?"stdin":argv[1]);
    ofile_printf("<BODY bgcolor=#f0f0f0 text=#000000 vlink==#6666ff link=#6666ff>");
    while(!feof(fp)) {
 	nchars = fread(buf,1,100000,fp);
	buf[nchars] = 0;
	latex2html(buf,1,1);
    }
    ofile_printf("</BODY>\n");
    return 0;
}
#endif


