
#line 6 "Tok.mx"

/* Copyright (C) 1998-2001 Contributors 

* This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by  
*  the Free Software Foundation; either version 2 of the License, or  
*  (at your option) any later version.  
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of   
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
*  GNU General Public License for more details.  
*
*  You should have received a copy of the GNU General Public License  
*  along with this program; if not, write to the Free Software  
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/


#include	<stdio.h>
#include	<ctype.h>

#include	"Mx.h"
#include	"MxFcnDef.h"

Tok *	FstTok(s)
char *	s;
{
Tok *	t;

	if( s == 0 )
		return 0;

	t= (Tok *) Malloc(sizeof(Tok));
	t->t_dir= '\0';
	t->t_str= 0;
	t->t_ext= '\0';
	t->t_nxt= s;
	t->t_chr= s[0];

	t= NxtTok(t);
	return t;
}

Tok *	NxtTok(t)
Tok *	t;
{
/* Restore */
	t->t_nxt[0]= t->t_chr;
	if( t->t_dir ) {
		if( t->t_chr == MARK )
			t->t_nxt++;
		if( t->t_ext != '\0' )
			t->t_nxt++;
	}

/* NxtTok */
	if( t->t_nxt[0] == '\0' ){
		free((char *) t); t= 0;
		return t;
	}
	if( (t->t_nxt[0] == MARK) && (CallDir(t->t_nxt[1]))){
	        int hook=0;
		int ok=1;

		t->t_nxt++;
		t->t_dir= *t->t_nxt++;
		t->t_str= t->t_nxt;

		if( !HideDir(t->t_dir) )
			for( ;(t->t_nxt[0] && ok); t->t_nxt++ ) {
			    switch(t->t_nxt[0]){
			    case '\n': ok= 0; break;
			    case '(': 
				if (t->t_nxt[-1] != '\\') hook++;
				break;
			    case ')': 
				if (t->t_nxt[-1] != '\\') hook--;
				break;
			    case MARK:
				if (t->t_nxt[-1] != '\\' && (hook==0))
				    ok = 0;
				break;
			    }
			}
		t->t_chr= t->t_nxt[0];
		t->t_nxt[-1]= '\0';
		if( t->t_dir == '`' )
			t->t_ext= t->t_nxt[1];
		DbTok(t);
		return t;
	}

	if( (t->t_nxt[0] == MARK) && (CtlDir(t->t_nxt[1])) ){
		t->t_nxt++;
		t->t_dir= *t->t_nxt++;
		t->t_str= t->t_nxt;

		if( !HideDir(t->t_dir) )
			for( ; t->t_nxt[0]; t->t_nxt++ ) {
				if( (t->t_nxt[0] == '\n') )
					break;
				if( (t->t_nxt[0] == MARK) && (t->t_nxt[-1] != '\\') )
					break;
			}
		t->t_chr= t->t_nxt[0];
		t->t_nxt[0]= '\0';
		if( t->t_dir == '`' )
			t->t_ext= t->t_nxt[1];
		DbTok(t);
		return t;
	}

	if( (t->t_nxt[0] == '\\') && (t->t_nxt[1] == MARK) ){
		t->t_dir= '\0';
		t->t_str= t->t_nxt+1;
		t->t_ext= '\0';
		t->t_nxt+= 2;
		t->t_chr= t->t_nxt[0];
		t->t_nxt[0]= '\0';
		return t;
	}

	t->t_dir= '\0';
	t->t_str= t->t_nxt;
	t->t_ext= '\0';
	t->t_nxt++;
	t->t_chr= t->t_nxt[0];
	t->t_nxt[0]= '\0';

	return t;
}

Tok *SkipTok(t, tok)
Tok *t;
char tok;
{
	char 	*s;
	
	t->t_str[0] = t->t_chr;
	for(s = t->t_str; *s; s++){
		switch(*s){
		case MARK :
			if (s[1] == tok) 
				return FstTok(s);
		case '\n' :
			mx_line++;
			break;
		case '\\':
			if (s[1] == MARK) s += 2;
			break;
		}
	}
	return 0;
	
}

void	DbTok(t)
Tok *	t;
{
	if( (db_flag & DB_TOK) == DB_TOK ){
		if( t != 0 )
			fprintf(stderr, "Tok[d:%c,s:%s,e:%c,c:%c,n:%c]\n",
				t->t_dir,t->t_str,t->t_ext,t->t_chr,t->t_nxt[1]);
		else
			fprintf(stderr, "Tok[NIL]\n");
	}
}


#line 177 "Tok.mx"
#define M_ARGS	9

char **	MkArgv(str)
char *	str;
{
char **	argv;
int	argc= 0;
int	level= 0;
char *	c;
int	i;

	argv= (char **) Malloc(sizeof(char *) * (M_ARGS + 1));
	for( argc= 0; argc <= M_ARGS; argc++ )
		argv[argc]= 0;
	argc= -1;
	argv[0]= c= StrDup(str);
	
	i= 0;
	for( c= argv[0]; *c; c++){
		switch( *c ){
		case '(':
			level++;
			if( level == 1 ){
				*c = '\0';
				argv[++i]= c + 1;
			}
			break;
		case ')':
			if( level == 1 ){
				*c= '\0';
				argc= i;
			}
			level--;
			break;
		case ',':
			if( level == 1 ){
				*c= '\0';
				argv[++i]= c + 1;
			}
			break;
		}
		if( argc == (M_ARGS + 1) )
			Fatal("MkArgv", "Too many arguments:%s", str);
	}
	if( level != 0 )
		Fatal("MkArgv", "Unbalanced Argument:%s", str);
	DbArgv(argv);
	return argv;
}

char **	RmArgv(argv)
char **	argv;
{
	Free((char *) argv[0]);
	Free((char *) argv);
	
	return 0;
}

void	DbArgv(argv)
char **	argv;
{
int	argc;

	if( (db_flag & DB_TOK) == DB_TOK ){
		fprintf(stderr, "Argv:");
		for( argc= 0; *argv && (argc <= M_ARGS); argc++ )
			fprintf(stderr, "argv[%d]:%s", argc, argv[argc]);
		fprintf(stderr, ".\n");
	}
}	

